--[[----------------------------------------------------------------------------
To add a localization:

	* Make a copy of this file (e.g. Localization.deDE.lua)
	* Uncomment the GetLocale line below, replacing xxXX with the appropriate code
	* Complete localization of the strings in the new file
	* Add the new file to AddOnStudioSamples.toc as instructed there

Notes:

	* enUS will always load before any other locales. This means you can comment
	  out any of the string definitions below and it will default to the English
		version.

--]]----------------------------------------------------------------------------

-- if GetLocale() ~= "xxXX" then return end

AOSS_LOCAL_STRINGS = AOSS_LOCAL_STRINGS or {}
local L = AOSS_LOCAL_STRINGS

--[[----------------------------------------------------------------------------
Global
--]]----------------------------------------------------------------------------

L.TITLE = "AddOn Studio Samples"

L.SLASH1 = "/addonstudiosamples"
L.SLASH2 = "/addonstudio"
L.SLASH3 = "/samples"
L.SLASH4 = "/aoss"

--[[----------------------------------------------------------------------------
Controls
--]]----------------------------------------------------------------------------
	
L.CONTROLS_NAME = "Controls"
L.CONTROLS_PANEL_TEXT = "This category demonstrates various UI widgets available to AddOn designers."
		
L.CONTROLS_BUTTONS_NAME = "Buttons"

L.CONTROLS_FONTSTRINGS_NAME = "FontStrings"
	
L.CONTROLS_TEXTURES_NAME = "Textures"
	
L.CONTROLS_EDITBOXES_NAME = "EditBoxes"
	
L.CONTROLS_GAMETOOLTIPS_NAME = "GameTooltips"
	
L.CONTROLS_SLIDERS_NAME = "Sliders"
	
L.CONTROLS_DROPDOWNS_NAME = "Dropdowns"
	
L.CONTROLS_SIMPLEHTML_NAME = "SimpleHTML Frames"
	
L.CONTROLS_SCROLLINGMESSAGE_NAME = "ScrollingMessageFrames"
	
L.CONTROLS_MODELS_NAME = "Models"
	
--[[----------------------------------------------------------------------------
Designing Frames
--]]----------------------------------------------------------------------------

L.DESIGNING_NAME = "Designing Frames"
L.DESIGNING_PANEL_TEXT = "These are examples of various UI design techniques."
	
L.DESIGNING_ANCHORING_NAME = "Frame Anchoring"
	
L.DESIGNING_APPEARANCE_NAME = "Frame Appearance"
	
L.DESIGNING_TEMPLATES_NAME = "Inheriting Styles"
	
L.DESIGNING_CUSTOMIZING_NAME = "Customizing Blizzard Frames"

--[[----------------------------------------------------------------------------
Lua Basics
--]]----------------------------------------------------------------------------
	
L.LUA_BASICS_NAME = "Lua Basics"
L.LUA_BASICS_PANEL_TEXT = "Here you will see some simple examples of working with the Lua language."
	
L.LUA_BASICS_LOGIC_NAME = "Logic Constructs"
	
L.LUA_BASICS_STRINGS_NAME = "Strings"
	
L.LUA_BASICS_TABLES_NAME = "Tables"
	
L.LUA_BASICS_FUNCTIONS_NAME = "Functions"
	
--[[----------------------------------------------------------------------------
WoW Systems
--]]----------------------------------------------------------------------------
	
L.WOW_SYSTEMS_NAME = "WoW Systems"
L.WOW_SYSTEMS_PANEL_TEXT = "This section covers advanced aspects of the WoW API and built-in UI systems."
	
L.WOW_SYSTEMS_TIMER_NAME = "Building a Timer"
	
L.WOW_SYSTEMS_EVENTS_NAME = "Handling Events"
	
L.WOW_SYSTEMS_SLASH_COMMANDS_NAME = "Slash Commands"
	
L.WOW_SYSTEMS_SAVED_VARIABLES_NAME = "Saved Variables"
	
L.WOW_SYSTEMS_INFO_EXCHANGE_NAME = "Exchanging Information"

L.WOW_SYSTEMS_LOCALIZATION_NAME = "Localization"
	
--[[----------------------------------------------------------------------------
WoW Systems
--]]----------------------------------------------------------------------------
	
L.DEBUGGING_NAME = "Debugging"
L.DEBUGGING_PANEL_TEXT = "Here you'll see some helpful examples for debugging AddOns."
	
L.DEBUGGING_ERRORS_NAME = "Handling Errors"
	
L.DEBUGGING_PERFORMANCE_NAME = "Tracking Performance"
