﻿using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;
using NUnit.Framework;

namespace Microsoft.WowAddonStudio.FrameXml.Components.Tests
{
	[TestFixture]
	public class FrameXmlControlTest : FrameXmlControlTestBase
	{
		[SetUp]
		public override void SetUp()
		{
			base.SetUp();

			RegisterWowTocFile();
		}

		[TearDown]
		public override void TearDown()
		{
			Assert.IsNotNull(UiControl);
			AssertControl(UiControl);

			base.TearDown();
		}

		[Test]
		[Ignore]
		public void ButtonTest()
		{
			InitializeUi("Data/Simple/Button.xml");
		}

		[Test]
		[Ignore]
		public void CheckButtonTest()
		{
			InitializeUi("Data/Simple/CheckButton.xml");
		}

		[Test]
		[Ignore]
		public void FontStringTest()
		{
			InitializeUi("Data/Simple/FontString.xml");
		}

		[Test]
		[Ignore]
		public void FrameBackdropTest()
		{
			InitializeUi("Data/Simple/FrameBackdrop.xml");
		}

		[Test]
		[Ignore]
		public void FrameLayoutTest()
		{
			InitializeUi("Data/Simple/FrameLayout.xml");
		}

		[Test]
		[Ignore]
		public void DialogBoxFrameTest()
		{
			InitializeUi("Data/Simple/DialogBoxFrame.xml");
		}

		[Test]
		[Ignore]
		public void TextureTest()
		{
			InitializeUi("Data/Simple/Texture.xml");
		}

		[Test]
		[Ignore]
		public void EditBoxTest()
		{
			InitializeUi("Data/Simple/EditBox.xml");
		}

		[Test]
		[Ignore]
		public void ColorSelectTest()
		{
			InitializeUi("Data/Simple/ColorSelect.xml");
		}

		[Test]
		[Ignore]
		public void StatusBarTest()
		{
			InitializeUi("Data/Simple/StatusBar.xml");
		}

		[Test]
		[Ignore]
		public void ScrollFrameTest()
		{
			InitializeUi("Data/Simple/ScrollFrame.xml");
		}

		[Test]
		[Ignore]
		public void WorldFrameTest()
		{
			InitializeUi("Data/Simple/WorldFrame.xml");
		}

		[Test]
		[Ignore]
		public void Test_Minimap()
		{
			InitializeUi(GetXmlResource(typeof (Minimap)));
		}

		[Test]
		[Ignore]
		public void Test_MessageFrame()
		{
			InitializeUi(GetXmlResource(typeof (MessageFrame)));
		}
	}
}