using Microsoft.WowAddonStudio.FrameXml.Services;

namespace Microsoft.WowAddonStudio.FrameXml.Components.Tests.Mocks
{
	public class MockFrameXmlImageService : FrameXmlImageService
	{
		/// <summary>
		/// Initializes a new instance of the <see cref="MockFrameXmlImageService"/> class.
		/// </summary>
		/// <param name="resourceFileLoader">The resource file loader.</param>
		public MockFrameXmlImageService(ResourceFileLoader resourceFileLoader) : base(resourceFileLoader)
		{
		}

		/// <summary>
		/// Checks whether an image exists.
		/// </summary>
		/// <param name="imagePath">The path to the image.</param>
		/// <returns>
		/// True, if the image exists; False otherwise.
		/// </returns>
		public override bool ImageExists(string imagePath)
		{
			return imagePath.StartsWith("Test");
		}
	}
}