using System.Diagnostics;
using Microsoft.WowAddonStudio.FrameXml.Components.Layout;

namespace Microsoft.WowAddonStudio.FrameXml.Components.Tests.Mocks
{
	public class MockFrameXmlLayoutEngine : FrameXmlLayoutEngine
	{
		/// <summary>
		/// Initializes layout management for the FrameXML control.
		/// </summary>
		/// <param name="control">The FrameXML control.</param>
		public override void InitLayout(IFrameXmlControl control)
		{
			Trace.WriteLine("InitLayout");
		}

		/// <summary>
		/// Performs layout for the FrameXML control.
		/// </summary>
		/// <param name="control">The FrameXML control.</param>
		/// <param name="affectedProperty">The affected property.</param>
		public override void Layout(IFrameXmlControl control, string affectedProperty)
		{
			Trace.WriteLine("Layout");
		}

		/// <summary>
		/// Removes the layout.
		/// </summary>
		/// <param name="component">The control.</param>
		public override void RemoveLayout(IFrameXmlComponent component)
		{
			Trace.WriteLine("RemoveLayout");	
		}

		/// <summary>
		/// Adds the dependency.
		/// </summary>
		/// <param name="controlName">Name of the control.</param>
		/// <param name="dependencyName">Name of the dependency.</param>
		protected override void AddDependency(string controlName, string dependencyName)
		{
			Trace.WriteLine("AddDependency");
		}
	}
}