﻿using System;
using System.ComponentModel;
using System.Drawing;
using Microsoft.WowAddonStudio.FrameXml.Components.Events;
using Microsoft.WowAddonStudio.FrameXml.Serialization;
using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
	[ToolboxBitmap(typeof(System.Windows.Forms.ColorDialog), "ColorDialog.bmp")]
	[ToolboxItemFilter("WowAddonStudio", ToolboxItemFilterType.Require)]
    [EventGroup(EventGroup.ColorSelect, EventName.OnColorSelect)]
    public class ColorSelectControl : FrameControl
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="ColorSelectControl"/> class.
		/// </summary>
    	public ColorSelectControl()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="ColorSelectControl"/> class.
        /// </summary>
        /// <param name="colorSelect">The color select.</param>
        public ColorSelectControl(ColorSelect colorSelect)
            : base(colorSelect)
        {
        }

        /// <summary>
        /// Gets the color select.
        /// </summary>
        public ColorSelect ColorSelect
        {
            get
            {
                return this.SerializationObject as ColorSelect;
            }
        }

		/// <summary>
		/// Gets the type of the serialization object this control manages.
		/// </summary>
		public override Type SerializationObjectType
		{
			get
			{
				return typeof(ColorSelect);
			}
		}

        /// <summary>
        /// Gets the default size of a FrameXML control.
        /// </summary>
        /// <value></value>
        protected override Size DefaultSize
        {
            get { return new Size(200, 200); }
        }
    }
}