﻿using System;
using System.ComponentModel;

namespace Microsoft.WowAddonStudio.FrameXml.Components.Descriptors.Filters
{
    public class PropertyDescriptorFilter
    {
        /// <summary>
        /// Filters the property descriptor on the specified instance.
        /// </summary>
        /// <param name="instance">The instance.</param>
        /// <param name="propertyDescriptor">The property descriptor.</param>
        /// <returns>A property descriptor</returns>
        public virtual PropertyDescriptor Filter(object instance, PropertyDescriptor propertyDescriptor)
        {
            if (instance == null)
                throw new ArgumentNullException("instance");
            if (propertyDescriptor == null) 
                throw new ArgumentNullException("propertyDescriptor");

            return propertyDescriptor;
        }
    }
}
