﻿using System;
using System.Collections;
using System.ComponentModel.Design;

namespace Microsoft.WowAddonStudio.FrameXml.Components.Designers
{
    public class LayoutFrameComponentDesigner : ComponentDesigner, ILayoutFrameDesignerEvents
    {
        /// <summary>
        /// Occurs when [initialized new component].
        /// </summary>
        public event EventHandler<FrameDesignerEventArgs> InitializedNewComponent;

        /// <summary>
        /// Initializes a newly created component.
        /// </summary>
        /// <param name="defaultValues">A name/value dictionary of default values to apply to properties. May be null if no default values are specified.</param>
        public override void InitializeNewComponent(IDictionary defaultValues)
        {
            base.InitializeNewComponent(defaultValues);

            if (InitializedNewComponent != null)
                InitializedNewComponent(this, new FrameDesignerEventArgs(Component));
        }
    }
}
