﻿using System;
using System.ComponentModel;
using Microsoft.WowAddonStudio.FrameXml.Components.Designers;
using Microsoft.WowAddonStudio.FrameXml.Serialization;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
    [Designer(typeof(LayoutFrameComponentDesigner))]
    public class FontComponent : FrameXmlComponent<Font>
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="FontComponent"/> class.
		/// </summary>
    	public FontComponent()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="FontComponent"/> class.
        /// </summary>
        /// <param name="font">The font.</param>
        public FontComponent(Font font)
            : base(font)
        {
        }

        /// <summary>
        /// Gets the font.
        /// </summary>
        public Font Font
        {
            get { return SerializationObject as Font; }
        }

        /// <summary>
        /// Gets the type of the serialization object this control manages.
        /// </summary>
        /// <value></value>
        public override Type SerializationObjectType
        {
            get { return typeof(Font); }
        }
    }
}
