﻿using System;
using System.ComponentModel;
using System.Drawing;
using Microsoft.WowAddonStudio.FrameXml.Components.Designers;
using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
	[ToolboxBitmap(typeof(System.Windows.Forms.ToolTip), "ToolTip.bmp")]
	[ToolboxItemFilter("WowAddonStudio", ToolboxItemFilterType.Require)]
    [Designer(typeof(LayoutFrameComponentDesigner))]
    public class GameTooltipComponent : FrameXmlComponent<GameTooltip>
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="GameTooltipComponent"/> class.
		/// </summary>
    	public GameTooltipComponent()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="GameTooltipComponent"/> class.
        /// </summary>
        /// <param name="gameTooltip">The game tooltip.</param>
        public GameTooltipComponent(GameTooltip gameTooltip)
            : base(gameTooltip)
        {
        }

        /// <summary>
        /// Gets the game tooltip.
        /// </summary>
        public GameTooltip GameTooltip
        {
            get { return SerializationObject as GameTooltip; }
        }

        /// <summary>
        /// Gets the type of the serialization object this control manages.
        /// </summary>
        /// <value></value>
        public override Type SerializationObjectType
        {
            get { return typeof(GameTooltip); }
        }
    }
}
