﻿using System;
using System.ComponentModel;
using System.Drawing;
using Microsoft.WowAddonStudio.FrameXml.Components.Events;
using Microsoft.WowAddonStudio.FrameXml.Serialization;
using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
	[ToolboxBitmap(typeof(System.Windows.Forms.GroupBox), "GroupBox.bmp")]
	[ToolboxItemFilter("WowAddonStudio", ToolboxItemFilterType.Require)]
    [EventGroup(EventGroup.MessageFrame, EventName.OnLoad)]
	public class MessageFrameControl : FrameControl
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="MessageFrameControl"/> class.
		/// </summary>
    	public MessageFrameControl()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="MessageFrameControl"/> class.
        /// </summary>
        /// <param name="frame">The frame.</param>
        public MessageFrameControl(MessageFrame frame)
            : base(frame)
        {
        }

        /// <summary>
        /// Gets the message frame.
        /// </summary>
        public MessageFrame MessageFrame
        {
            get { return this.SerializationObject as MessageFrame; }
        }

		/// <summary>
		/// Gets the type of the serialization object this control manages.
		/// </summary>
		public override Type SerializationObjectType
		{
			get
			{
				return typeof(MessageFrame);
			}
		}

        /// <summary>
        /// Gets the default size of a FrameXML control.
        /// </summary>
        /// <value></value>
        protected override Size DefaultSize
        {
            get { return new Size(200, 200); }
        }
    }
}
