﻿using System;
using System.ComponentModel;
using System.Drawing;
using Microsoft.WowAddonStudio.FrameXml.Components.Events;
using Microsoft.WowAddonStudio.FrameXml.Components.Support;
using Microsoft.WowAddonStudio.FrameXml.Serialization;
using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
	[ToolboxBitmap(typeof(System.Windows.Forms.BindingSource), "BindingSource.bmp")]
	[ToolboxItemFilter("WowAddonStudio", ToolboxItemFilterType.Require)]
    [EventGroup(EventGroup.Model, EventName.OnUpdateModel)]
    public class ModelControl : FrameControl
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="ModelControl"/> class.
		/// </summary>
    	public ModelControl()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="ModelControl"/> class.
        /// </summary>
        /// <param name="model">The model.</param>
        public ModelControl(Model model)
            : base(model)
        {
        }

        /// <summary>
        /// Gets the model.
        /// </summary>
        public Model Model
        {
            get { return this.SerializationObject as Model; }
        }

		/// <summary>
		/// Gets the type of the serialization object this control manages.
		/// </summary>
		public override Type SerializationObjectType
		{
			get
			{
				return typeof(Model);
			}
		}

		/// <summary>
		/// Draws the FrameXML control.
		/// </summary>
		/// <param name="graphics">The <see cref="FrameXmlGraphics"/> context to draw to.</param>
		/// <param name="rectangle">The <see cref="Rectangle"/> to draw to.</param>
		public override bool DrawControl(FrameXmlGraphics graphics, Rectangle rectangle)
		{
			//graphics.DrawModel(this.Model, rectangle);
		    return false;
		}

        /// <summary>
        /// Gets the default size of a FrameXML control.
        /// </summary>
        /// <value></value>
        protected override Size DefaultSize
        {
            get { return new Size(200, 250); }
        }
    }
}
