﻿using System;
using System.ComponentModel;
using System.Drawing;
using Microsoft.WowAddonStudio.FrameXml.Components.Events;
using Microsoft.WowAddonStudio.FrameXml.Serialization;
using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
    [ToolboxItem(false)]
	[ToolboxBitmap(typeof(BackgroundWorker), "BackgroundWorker.bmp")]
	[ToolboxItemFilter("WowAddonStudio", ToolboxItemFilterType.Require)]
    [EventGroup(EventGroup.Frame, EventName.OnMovieFinished)]
    public class MovieFrameControl : FrameControl
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="MovieFrameControl"/> class.
		/// </summary>
    	public MovieFrameControl()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="MovieFrameControl"/> class.
        /// </summary>
        /// <param name="frame">The movie frame.</param>
        public MovieFrameControl(MovieFrame frame)
            : base(frame)
        {
        }

        /// <summary>
        /// Gets the Movie frame.
        /// </summary>
        /// <value>The MovieFrame.</value>
        public MovieFrame MovieFrame
        {
            get { return this.SerializationObject as MovieFrame; }
        }

        /// <summary>
        /// Gets the type of the serialization object this control manages.
        /// </summary>
        public override Type SerializationObjectType
        {
            get
            {
                return typeof(MovieFrame);
            }
        }

        /// <summary>
        /// Gets the default size of a FrameXML control.
        /// </summary>
        /// <value></value>
        protected override Size DefaultSize
        {
            get { return new Size(320, 240); }
        }
    }
}
