﻿using System;
using System.ComponentModel;
using System.Drawing;
using Microsoft.WowAddonStudio.FrameXml.Components.Events;
using Microsoft.WowAddonStudio.FrameXml.Serialization;
using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
	[ToolboxBitmap(typeof(System.Windows.Forms.ListBox), "ListBox.bmp")]
	[ToolboxItemFilter("WowAddonStudio", ToolboxItemFilterType.Require)]
    [EventGroup(EventGroup.ScrollFrame, EventName.OnVerticalScroll)]
    public class ScrollFrameControl : FrameControl
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="ScrollFrameControl"/> class.
		/// </summary>
    	public ScrollFrameControl()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="ScrollFrameControl"/> class.
        /// </summary>
        /// <param name="scrollFrame">The scroll frame.</param>
        public ScrollFrameControl(ScrollFrame scrollFrame)
            : base(scrollFrame)
        {
        }

        /// <summary>
        /// Gets the scroll frame.
        /// </summary>
        public ScrollFrame ScrollFrame
        {
            get { return this.SerializationObject as ScrollFrame; }
        }

		/// <summary>
		/// Gets the type of the serialization object this control manages.
		/// </summary>
		public override Type SerializationObjectType
		{
			get
			{
				return typeof(ScrollFrame);
			}
		}

        /// <summary>
        /// Gets the default size of a FrameXML control.
        /// </summary>
        /// <value></value>
        protected override Size DefaultSize
        {
            get { return new Size(200, 200); }
        }
    }
}
