﻿using System;
using System.ComponentModel;
using System.Drawing;
using Microsoft.WowAddonStudio.FrameXml.Components.Events;
using Microsoft.WowAddonStudio.FrameXml.Serialization;
using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
	[ToolboxBitmap(typeof(System.Windows.Forms.VScrollBar), "VScrollBar.bmp")]
	[ToolboxItemFilter("WowAddonStudio", ToolboxItemFilterType.Require)]
    [EventGroup(EventGroup.ScrollingMessageFrame, EventName.OnLoad)]
    public class ScrollingMessageFrameControl : FrameControl
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="ScrollingMessageFrameControl"/> class.
		/// </summary>
    	public ScrollingMessageFrameControl()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="ScrollingMessageFrameControl"/> class.
        /// </summary>
        /// <param name="frame">The frame.</param>
        public ScrollingMessageFrameControl(ScrollingMessageFrame frame)
            : base(frame)
        {
        }

        /// <summary>
        /// Gets the ScrollingMessageFrame.
        /// </summary>
        /// <value>The ScrollingMessageFrame.</value>
        public ScrollingMessageFrame ScrollingMessageFrame
        {
            get { return this.SerializationObject as ScrollingMessageFrame; }
        }

        /// <summary>
        /// Gets the type of the serialization object this control manages.
        /// </summary>
        public override Type SerializationObjectType
        {
            get
            {
                return typeof(ScrollingMessageFrame);
            }
        }

        /// <summary>
        /// Gets the default size of a FrameXML control.
        /// </summary>
        /// <value></value>
        protected override Size DefaultSize
        {
            get { return new Size(200, 200); }
        }
    }
}
