﻿using System;
using System.ComponentModel;
using System.Drawing;
using Microsoft.WowAddonStudio.FrameXml.Components.Events;
using Microsoft.WowAddonStudio.FrameXml.Serialization;
using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
	[ToolboxBitmap(typeof(System.Windows.Forms.TrackBar), "TrackBar.bmp")]
	[ToolboxItemFilter("WowAddonStudio", ToolboxItemFilterType.Require)]
    [EventGroup(EventGroup.Slider, EventName.OnValueChanged)]
    public class SliderControl : FrameControl
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="SliderControl"/> class.
		/// </summary>
    	public SliderControl()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="SliderControl"/> class.
        /// </summary>
        /// <param name="slider">The slider.</param>
        public SliderControl(Slider slider)
            : base(slider)
        {
        }

		/// <summary>
		/// Gets the slider.
		/// </summary>
		/// <value>The slider.</value>
        public Slider Slider
        {
            get { return this.SerializationObject as Slider; }
        }

        /// <summary>
        /// Gets the type of the serialization object this control manages.
        /// </summary>
        public override Type SerializationObjectType
        {
            get
            {
                return typeof(Slider);
            }
        }

        /// <summary>
        /// Gets the default size of a FrameXML control.
        /// </summary>
        /// <value></value>
        protected override Size DefaultSize
        {
            get { return new Size(20, 110); }
        }
    }
}
