﻿using System;
using System.ComponentModel;
using System.Drawing;
using Microsoft.WowAddonStudio.FrameXml.Components.Events;
using Microsoft.WowAddonStudio.FrameXml.Components.Support;
using Microsoft.WowAddonStudio.FrameXml.Serialization;
using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;

namespace Microsoft.WowAddonStudio.FrameXml.Components
{
	[ToolboxBitmap(typeof(System.Windows.Forms.StatusStrip), "StatusStrip.bmp")]
	[ToolboxItemFilter("WowAddonStudio", ToolboxItemFilterType.Require)]
    [EventGroup(EventGroup.StatusBar, EventName.OnValueChanged)]
    public class StatusBarControl : FrameControl
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="StatusBarControl"/> class.
		/// </summary>
    	public StatusBarControl()
    	{
    	}

    	/// <summary>
        /// Initializes a new instance of the <see cref="StatusBarControl"/> class.
        /// </summary>
        /// <param name="statusBar">The status bar.</param>
        public StatusBarControl(StatusBar statusBar)
            : base(statusBar)
        {
        }

        /// <summary>
        /// Gets the status bar.
        /// </summary>
        public StatusBar StatusBar
        {
            get { return this.SerializationObject as StatusBar; }
        }

		/// <summary>
		/// Gets the type of the serialization object this control manages.
		/// </summary>
		public override Type SerializationObjectType
		{
			get
			{
				return typeof(StatusBar);
			}
		}

        /// <summary>
        /// Gets the default size of a FrameXML control.
        /// </summary>
        /// <value></value>
        protected override Size DefaultSize
        {
            get { return new Size(212, 14); }
        }
    }
}
