﻿using System;

namespace Microsoft.WowAddonStudio.FrameXml.Components.Support
{
    public class FrameXmlControlEventArgs : EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FrameXmlControlEventArgs"/> class.
        /// </summary>
        /// <param name="control">The frame XML control.</param>
        public FrameXmlControlEventArgs(IFrameXmlControl control)
        {
            if (control == null)
                throw new ArgumentNullException("control");

            Control = control;
        }

        /// <summary>
        /// Gets the FrameXML control.
        /// </summary>
        public IFrameXmlControl Control { get; private set; }
    }
}
