﻿using Microsoft.WowAddonStudio.FrameXml.Design.Tests.Properties;
using Microsoft.WowAddonStudio.FrameXml.Services;
using NUnit.Framework;

namespace Microsoft.WowAddonStudio.FrameXml.Design.Tests
{
    [TestFixture]
    public class FrameXmlDesignerFactoryTest
    {
        private readonly FrameXmlDesignerFactory designerFactory = new FrameXmlDesignerFactory();

        [SetUp]
        public void SetUp()
        {
            designerFactory.WowBasePath = Settings.Default.WowBasePath;
        }

        [Test]
        public void DesignSurfaceTest()
        {
            var designSurface = designerFactory.CreateDesignSurface();

            Assert.IsNotNull(designSurface);
        }
        
        [Test]
        public void DesignSurfaceServiceProviderTest()
        {
            var designSurface = designerFactory.CreateDesignSurface();

            // Assert that the required FrameXML services are available
            Assert.IsNotNull(designSurface.GetService(typeof(FrameXmlFontService)));
            Assert.IsNotNull(designSurface.GetService(typeof(FrameXmlImageService)));
        }
    }
}
