﻿using System;
using System.ComponentModel.Design;

namespace Microsoft.WowAddonStudio.FrameXml.Design
{
    public class FrameXmlDesignSurface : DesignSurface
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FrameXmlDesignSurface"/> class.
        /// </summary>
        public FrameXmlDesignSurface()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="FrameXmlDesignSurface"/> class.
        /// </summary>
        /// <param name="parentProvider">The parent provider.</param>
        public FrameXmlDesignSurface(IServiceProvider parentProvider) : base(parentProvider)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="FrameXmlDesignSurface"/> class.
        /// </summary>
        /// <param name="parentProvider">The parent service provider, or null if there is no parent used to resolve services.</param>
        /// <param name="rootComponentType">The type of root component to create.</param>
        /// <exception cref="T:System.ArgumentNullException">
        /// 	<paramref name="rootComponentType"/> is null.</exception>
        /// <exception cref="T:System.ObjectDisposedException">The <see cref="T:System.ComponentModel.Design.IDesignerHost"/>  attached to the <see cref="T:System.ComponentModel.Design.DesignSurface"/>  has been disposed.</exception>
        public FrameXmlDesignSurface(IServiceProvider parentProvider, Type rootComponentType) : base(parentProvider, rootComponentType)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="FrameXmlDesignSurface"/> class.
        /// </summary>
        /// <param name="rootComponentType">Type of the root component.</param>
        public FrameXmlDesignSurface(Type rootComponentType) : base(rootComponentType)
        {
        }
    }
}
