using System;

namespace Microsoft.WowAddonStudio.FrameXml.Editor.ToolWindows
{
	/// <summary>
	///  System.EventArgs is the base class for classes containing event data.
	/// </summary>
	public class FrameControlSelectedEventArgs : EventArgs
	{
		/// <summary>
		/// Initializes a new instance of the <see cref="FrameControlSelectedEventArgs"/> class.
		/// </summary>
		/// <param name="controlName">Name of the control.</param>
		public FrameControlSelectedEventArgs(string controlName)
		{
			ControlName = controlName;
		}

		/// <summary>
		/// Gets or sets the name of the control.
		/// </summary>
		/// <value>The name of the control.</value>
		public String ControlName { get; set; }
	}
}