using System;
using System.Windows.Forms;

namespace Microsoft.WowAddonStudio.FrameXml.Editor.ToolWindows
{
	public interface ILayoutControllerHost : IWin32Window
	{
		/// <summary>
		/// Occurs when [frame control state changed].
		/// </summary>
		event EventHandler<FrameControlStateChangedEventArgs> FrameControlStateChanged;

		/// <summary>
		/// Occurs when [frame control selected].
		/// </summary>
		event EventHandler<FrameControlSelectedEventArgs> FrameControlSelected;

		/// <summary>
		/// Occurs when [layout state changed].
		/// </summary>
		event EventHandler<LayoutStateChangedEventArgs> LayoutStateChanged;

		/// <summary>
		/// Gets or sets the TreeView object for the unfiltered (hierarchical) view.
		/// </summary>
		/// <returns>A TreeView object.</returns>
		TreeView LayoutTree { get; set; }
	}
}