﻿using System.Drawing;

namespace Microsoft.WowAddonStudio.FrameXml.Formats.Blp
{
    public abstract class MipMap
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MipMap"/> class.
        /// </summary>
        /// <param name="size">The size.</param>
        protected internal MipMap(Size size)
        {
            this.Size = size;
        }

        /// <summary>
        /// Gets the size of the mipmap.
        /// </summary>
        public Size Size { get; private set; }

        /// <summary>
        /// Gets the mipmap as an <see cref="Image"/>.
        /// </summary>
        /// <returns></returns>
        public abstract Image GetImage();

    }
}
