using Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames;
using NUnit.Framework;

namespace Microsoft.WowAddonStudio.FrameXml.Serialization.Tests
{
	[TestFixture]
	public class ParentFrameInheritanceTest : SerializationTestBase<Frame>
	{
		#region Tests

		[Test]
		public void ParentFrameTest()
		{
			InitializeTestEntity("Simple/ParentFrameInheritance.xml");

			Assert.AreEqual(0, TestEntity.Frames.Count);
			Assert.AreEqual(0, TestEntity.Layers.Count);
		}

		#endregion

		/// <summary>
		/// Gets the entity to be tested from a <see cref="Ui"/> instance.
		/// </summary>
		/// <param name="ui">The ui instance.</param>
		/// <returns>
		/// An instance of the <typeparamref name="TSerializationObject"/> class.
		/// </returns>
		protected override Frame GetTestEntity(Ui ui)
		{
			Assert.IsNotNull(ui.LayoutFrames);
			Assert.AreEqual(1, ui.LayoutFrames.Count);

			// Ui/Frame[1]
			Assert.IsTrue(ui.LayoutFrames[0] is Frame);
			return (Frame) ui.LayoutFrames[0];
		}
	}
}