using System;

namespace Microsoft.WowAddonStudio.FrameXml.Serialization.Attributes
{
    /// <summary>
    /// 
    /// </summary>
    [AttributeUsage(AttributeTargets.Property, AllowMultiple = false, Inherited = false)]
    public sealed class InheritedAttribute : Attribute
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InheritedAttribute"/> class.
        /// </summary>
        /// <param name="inherited">if set to <c>true</c> [inherited].</param>
        public InheritedAttribute(bool inherited)
        {
            Inherited = inherited;
        }

        /// <summary>
        /// Gets or sets a value indicating whether this <see cref="InheritedAttribute"/> is inherited.
        /// </summary>
        /// <value><c>true</c> if inherited; otherwise, <c>false</c>.</value>
        public bool Inherited { get; private set; }

        /// <summary>
        /// Returns a <see cref="T:System.String"/> that represents the current <see cref="T:System.Object"/>.
        /// </summary>
        /// <returns>
        /// A <see cref="T:System.String"/> that represents the current <see cref="T:System.Object"/>.
        /// </returns>
        public override string ToString()
        {
            return String.Concat("InheritedAttribute, Inherited: ", Inherited);
        }
    }
}