﻿namespace Microsoft.WowAddonStudio.FrameXml.Serialization
{

    /// <summary>
    /// Provides access to the inherited serialization object.
    /// </summary>
    /// <typeparam name="TSerializationObject">The type of the serialization object that is inheritable.</typeparam>
    public interface IInheritableObject<TSerializationObject> where TSerializationObject : SerializationObject
    {
        /// <summary>
        /// Gets or sets the inherited object.
        /// </summary>
        TSerializationObject InheritedObject { get; set; }
    }
}
