﻿using System;
using System.ComponentModel;
using System.Xml.Serialization;

namespace Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames
{
    /// <summary>
    /// Represents a gametooltip.
    /// </summary>
    [Serializable]
    [DesignerCategory("code")]
    [XmlType(Namespace = "http://www.blizzard.com/wow/ui/")]
    [XmlRoot(Namespace = "http://www.blizzard.com/wow/ui/", IsNullable = false)]
    public class GameTooltip : Frame
    {
        /// <summary>
        /// Determines whether this instance [can be inherited from] the specified inheritable object type.
        /// </summary>
        /// <param name="inheritableObjectType">Type of the inheritable object.</param>
        /// <returns>
        /// 	<c>true</c> if this instance [can be inherited from] the specified inheritable object type; otherwise, <c>false</c>.
        /// </returns>
        public override bool CanBeInheritedFrom(Type inheritableObjectType)
        {
            return inheritableObjectType == typeof(GameTooltip);
        }
        
        /// <summary>
        /// Returns a <see cref="T:System.String"/> that represents the current <see cref="T:System.Object"/>.
        /// </summary>
        /// <returns>
        /// A <see cref="T:System.String"/> that represents the current <see cref="T:System.Object"/>.
        /// </returns>
        public override string ToString()
        {
            return Name;
        }
    }
}