﻿using System;
using System.ComponentModel;
using System.Xml.Serialization;

namespace Microsoft.WowAddonStudio.FrameXml.Serialization.LayoutFrames
{
    [Serializable]
    [DesignerCategory("code")]
    [XmlType(Namespace = "http://www.blizzard.com/wow/ui/")]
    [XmlRoot(Namespace = "http://www.blizzard.com/wow/ui/", IsNullable = false)]
    public class ScrollingMessageFrame : MessageFrame
    {
        /// <summary>
        /// Gets or sets the maximum number of lines in the scrolling message frame. The default is 8.
        /// </summary>
        [XmlAttribute("maxLines")]
        [DefaultValue(8)]
        [Category("Behavior")]
        [Description("Defines the maximum number of lines to allow in a ScrollingMessageFrame.")]
        public int MaxLines
        {
            get { return Properties.GetValue<int>("MaxLines"); }
            set { Properties.SetValue("MaxLines", value); }
        }
    }
}