﻿using System;
using System.ComponentModel;
using System.Xml.Serialization;
using Microsoft.WowAddonStudio.FrameXml.Serialization.TypeConverters;

namespace Microsoft.WowAddonStudio.FrameXml.Serialization 
{
    [Serializable]
    [DesignerCategory("code")]
    [XmlType(AnonymousType = true, Namespace = "http://www.blizzard.com/wow/ui/")]
	[TypeConverter(typeof(ResizeBoundsTypeConverter))]
    public class ResizeBounds : SerializationObject 
    {
        /// <summary>
        /// Gets or sets the minimum resize dimensions.
        /// </summary>
        [XmlElement("minResize")]
		[Category("Layout")]
		[NotifyParentProperty(true)]
        public Dimension MinResize { get; set; }

        /// <summary>
        /// Gets or sets the maximum resize dimensions.
        /// </summary>
        [XmlElement("maxResize")]
		[Category("Layout")]
		[NotifyParentProperty(true)]
        public Dimension MaxResize { get; set; }
    }
}