using System;
using EnvDTE;

using Microsoft.WowAddonStudio.Tests.Common.Mocks;

using NUnit.Framework;

namespace Microsoft.WowAddonStudio.Lua.LanguageService.Tests
{
    public class LanguageServiceTestBase
    {
		/// <summary>
		/// Tests the fixture set up.
		/// </summary>
        [TestFixtureSetUp]
        public virtual void TestFixtureSetUp()
        {
            SimpleTestServiceLocator.Register<DTE>(new MockDTE());
        }

		/// <summary>
		/// Sets up.
		/// </summary>
        [SetUp]
        public virtual void SetUp()
        {
			Console.WriteLine("LanguageService test case started...");
        }

		/// <summary>
		/// Tests the fixture tear down.
		/// </summary>
        [TestFixtureTearDown]
        public virtual void TestFixtureTearDown()
        {
            SimpleTestServiceLocator.Reset();
        }

		/// <summary>
		/// Tears down.
		/// </summary>
        [TearDown]
        public virtual void TearDown()
        {
        }
    }
}