﻿using System;

using Microsoft.WowAddonStudio.Lua.Parser;

namespace Microsoft.WowAddonStudio.Lua.LanguageService.Model
{
    public class DataTip
    {
        /// <summary>
        /// Gets or sets the text of the data tip.
        /// </summary>
        public string Text { get; private set; }

        /// <summary>
        /// Gets or sets the location of the data tip.
        /// </summary>
        public LexLocation Location { get; private set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="DataTip"/> class.
        /// </summary>
        /// <param name="text">The text.</param>
        /// <param name="location">The location.</param>
        public DataTip(string text, LexLocation location)
        {
            if (text == null)
                throw new ArgumentNullException("text");
            if (location == null)
                throw new ArgumentNullException("location");

            Text = text;
            Location = location;
        }
    }
}
