namespace Microsoft.WowAddonStudio.Lua.RuntimeService.ShellHost
{
	/// <summary>
	/// 
	/// </summary>
	public sealed class ShellHostFactory : IShellHostFactory
	{
		/// <summary>
		/// Creates the shell host.
		/// </summary>
		/// <returns></returns>
		public IShellHost CreateShellHost()
		{
			return CreateShellHost(ShellHostType.CommandHost);
		}

		/// <summary>
		/// Creates the shell host.
		/// </summary>
		/// <param name="hostType">Type of the host.</param>
		/// <returns></returns>
		public IShellHost CreateShellHost(ShellHostType hostType)
		{
			switch (hostType)
			{
				case ShellHostType.CommandHost:
					return new CommandShellHost();
				case ShellHostType.AsyncCommandHost:
					return new AsyncCommandShellHost();
			}
			return null;
		}
	}
}