using System;

namespace Microsoft.WowAddonStudio.Lua.RuntimeService.WowBench
{
	/// <summary>
	/// Represents event data for CommandHistory events. 
	/// </summary>
	public class CommandHistoryEventArgs : EventArgs
	{
		/// <summary>
		/// Initializes a new instance of the <see cref="CommandHistoryEventArgs"/> class.
		/// </summary>
		/// <param name="command">The command text.</param>
		public CommandHistoryEventArgs(string command)
		{
			Command = command;
		}

		/// <summary>
		/// Gets the newly added command.
		/// </summary>
		public string Command { get; set; }

		/// <summary>
		/// Returns a <see cref="System.String"/> that 
		/// represents the current <see cref="CommandHistoryEventArgs"/>.
		/// </summary>
		/// <returns>The command text with class prefix.</returns>
		public override string ToString()
		{
			return String.Concat("CommandHistoryEventArgs: ", Command);
		}
	}
}