using System.Diagnostics;
using System.Xml.Serialization;

namespace Microsoft.WowAddonStudio.Lua.Model
{
    /// <summary>
    /// A Lua element that can hold documentation.
    /// </summary>
    /// <seealso cref="Declaration"/>
    [XmlType(Namespace = "http://schemas.microsoft.com/aos/2008/xmldoc")]
    [DebuggerDisplay("Name = {Name}")]
    public class Element
    {
        /// <summary>
        /// Gets or sets the name of the element.
        /// </summary>
        [XmlAttribute("name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the summary of the element.
        /// </summary>
        [XmlElement("summary")]
        [XmlText]
        public string Summary { get; set; }
    }
}