namespace Microsoft.WowAddonStudio.Lua.Parser
{
    //
    // These are the dummy declarations for stand-alone lex applications
    // normally these declarations would come from the parser.
    // 
    public interface IErrorHandler
    {
        /// <summary>
        /// Gets the number of errors.
        /// </summary>
        int ErrorCount { get; }

        /// <summary>
        /// Gets the number of warnings.
        /// </summary>
        int WarningCount { get; }

        /// <summary>
        /// Adds an error.
        /// </summary>
        /// <param name="message"></param>
        /// <param name="line"></param>
        /// <param name="column"></param>
        /// <param name="length"></param>
        /// <param name="isWarning"></param>
        void AddError(string message, int line, int column, int length, bool isWarning);
    }
}
