﻿using System;
using System.Runtime.InteropServices;
using Microsoft.VisualStudio.Project;
using Microsoft.VisualStudio.Project.Automation;

namespace Microsoft.WowAddonStudio.Project.Automation
{
    /// <summary>
    /// World of Warcraft project properties automation object.
    /// </summary>
    [ComVisible(true)]
    public class OAWowProjectProperties : OAProperties
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OAWowProjectProperties"/> class.
        /// </summary>
        /// <param name="nodeProperties">The node properties.</param>
        internal OAWowProjectProperties(NodeProperties nodeProperties)
            : base(nodeProperties)
        {
            AddProperties();
        }

        /// <summary>
        /// Initialize properties by names, which defined in property page tag.
        /// </summary>
        private void AddProperties()
        {
            foreach (string tag in Enum.GetNames(typeof (GeneralPropertyPageTag)))
            {
                if (!Properties.ContainsKey(tag))
                    Properties.Add(tag, new OAWowProjectProperty(this, tag));
            }
        }
    }
}