﻿using System;

namespace Microsoft.WowAddonStudio.Project.Import.Ace
{
	/// <summary>
	/// Implements specific settings for import from ace packages.
	/// </summary>
	public class AceImportSettings
	{
		/// <summary>
		/// Gets or sets the source uri.
		/// </summary>
		public Uri SourceUri { get; private set; }

		/// <summary>
		/// Initializes a new instance of the <see cref="AceImportSettings"/> class.
		/// </summary>
		/// <param name="sourceUri">The source URI.</param>
		public AceImportSettings(Uri sourceUri)
		{
			if (sourceUri == null)
				throw new ArgumentNullException("sourceUri");

			SourceUri = sourceUri;
		}
	}
}