﻿using System;

namespace Microsoft.WowAddonStudio.Project.Import.Folder
{
	/// <summary>
	/// Folder import specific settings.
	/// </summary>
	public class FolderImportSettings
	{
		/// <summary>
		/// Gets or sets the source uri.
		/// </summary>
		public Uri SourceUri { get; private set; }

		/// <summary>
		/// Initializes a new instance of the <see cref="FolderImportSettings"/> class.
		/// </summary>
		/// <param name="sourceUri">The source URI.</param>
		public FolderImportSettings(Uri sourceUri)
		{
			if (sourceUri == null)
				throw new ArgumentNullException("sourceUri");
			SourceUri = sourceUri;
		}
	}
}