﻿using System;
using System.IO;

namespace Microsoft.WowAddonStudio.Project.Import
{
    /// <summary>
    /// Represents the interface of an item that should be added to an
    /// Addon Studio project.
    /// </summary>
    public interface IAddonItem
    {
        /// <summary>
        /// Gets the relative path to the addon item.
        /// </summary>
        string RelativePath { get; }

        /// <summary>
        /// Gets the file type.
        /// </summary>
        FileType Type { get; }

        /// <summary>
        /// Gets the contents of the addon item as a stream.
        /// </summary>
        /// <returns>An instance of the <see cref="Stream"/> class.</returns>
        Stream GetStream();
    }
}
