﻿using System.ComponentModel;
using System.Drawing;

using Microsoft.WowAddonStudio.Project.Import;

namespace Microsoft.WowAddonStudio.Project.Import
{
	/// <summary>
	/// The first page of the input wizard.
	/// </summary>
	public partial class InitPane : ImportWizardPane
	{
		public InitPane()
		{
			InitializeComponent();
			initPictureBox.Image = Image.FromStream(
                typeof(InitPane).Assembly.GetManifestResourceStream("Microsoft.WowAddonStudio.Project.Resources.wizardinit.bmp"));
			SetActive += InitPane_SetActive;
		}

		/// <summary>
		/// Handles the SetActive event of the InitPane control.
		/// </summary>
		/// <param name="sender">The source of the event.</param>
		/// <param name="e">The <see cref="System.ComponentModel.CancelEventArgs"/> instance containing the event data.</param>
		private void InitPane_SetActive(object sender, CancelEventArgs e)
		{
			SetWizardButtons(WizardButtons.Next);
		}
	}
}