﻿using System.ComponentModel;

namespace Microsoft.WowAddonStudio.Project.Import
{
	/// <summary>
	/// Event handler delegate of all wizard page events.
	/// </summary>
	public delegate void WizardPageEventHandler(object sender, WizardPageEventArgs e);

	/// <summary>
	/// Event arg class that describes the parameters of wizard page events.
	/// The only parameter that is necessary is the next page to activate.
	/// </summary>
	public sealed class WizardPageEventArgs : CancelEventArgs
	{
		/// <summary>
		/// Index of new page to activate in wizard.
		/// </summary>
		public int NewPageIndex { get; set; }
	}
}