namespace Microsoft.WowAddonStudio.ProjectRefactor
{
    /// <summary>
    /// Defines methods for merging source code changes into project.
    /// </summary>
    public interface IFrameXmlMerger
    {
		/// <summary>
		/// Merges new text into file.
		/// </summary>
		/// <param name="newXml">The new XML.</param>
        void Merge(string newXml);

        /// <summary>
        /// Merges the new Lua code file name into the specified FramXml file as a refernce.
        /// </summary>
        /// <param name="frameXmlPath">Path of FrameXml file.</param>
        /// <param name="luaCodeFilePath">Path of Lua code file.</param>
        void MergeFrameName(string frameXmlPath, string luaCodeFilePath);
    }
}