﻿using System.Collections.Generic;

namespace Microsoft.WowAddonStudio.TocEditor
{
	/// <summary>
	/// Provides interface versions to be included in TOC
	/// file.
	/// </summary>
	public static class TocInterfaceProvider
	{
		/// <summary>
		/// Initializes the <see cref="TocInterfaceProvider"/> class.
		/// </summary>
		static TocInterfaceProvider()
		{
			//TODO: Get this from resource
			InterfaceVersions = new List<KeyValuePair<string, string>>
			                    	{
			                    		new KeyValuePair<string, string>("20100", "World of Warcraft 2.1.0 (20100)"),
			                    		new KeyValuePair<string, string>("20200", "World of Warcraft 2.2.0 (20200)"),
			                    		new KeyValuePair<string, string>("20300", "World of Warcraft 2.3.0 (20300)"),
			                    		new KeyValuePair<string, string>("20400", "World of Warcraft 2.4.0 (20400)")
			                    	};
		}

		/// <summary>
		/// Gets available interface versions along with their names.
		/// </summary>
		public static List<KeyValuePair<string, string>> InterfaceVersions { get; private set; }
	}
}