﻿using System.Runtime.InteropServices;
using Microsoft.VisualStudio.Project;

namespace Microsoft.WowAddonStudio.Project
{
	/// <summary>
	/// An object that deals with user interaction via a GUI in the form a hierarchy: a parent node with zero or more child nodes, each of which
	/// can itself be a hierarchy.  
	/// </summary>
    [Guid(GuidStrings.WowTocFileNode)]
    public class WowTocFileNode : WowFileNode
    {
		/// <summary>
		/// Initializes a new instance of the <see cref="WowTocFileNode"/> class.
		/// </summary>
		/// <param name="root">The root.</param>
		/// <param name="e">The e.</param>
        internal WowTocFileNode(ProjectNode root, ProjectElement e)
            : base(root, e)
        {
        }

		/// <summary>
		/// Gets the index of the image.
		/// </summary>
		/// <value>The index of the image.</value>
        public override int ImageIndex
        {
            get
            {
                return (int)ProjectNode.ImageName.SettingsFile;
            }
        }
    }
}
