﻿using System;
using System.Runtime.InteropServices;

namespace Microsoft.WowAddonStudio.Services
{
    [Guid("9F861120-C887-445b-805F-47F5AC9D3930")]
    public interface IAddonStudioSettings
    {
        /// <summary>
        /// Occurs when the background image file changes.
        /// </summary>
        event EventHandler BackgroundImageFileChanged;

        /// <summary>
        /// Gets the BackgroundImageFile setting.
        /// </summary>
        string BackgroundImageFile { get; }

		/// <summary>
		/// Gets the custom deployment location.
		/// </summary>
		string CustomDeploymentLocation { get; }

        /// <summary>
        /// Gets the custom path to WoWBench.
        /// </summary>
        string CustomWowBenchPath { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether [open in editor].
        /// </summary>
        /// <value><c>true</c> if [open in editor]; otherwise, <c>false</c>.</value>
        bool OpenInEditor { get; set; }
    }
}
