﻿using System;
using System.Runtime.InteropServices;

namespace Microsoft.WowAddonStudio.Services
{
    [Guid("7D440BAF-F0EE-4D7B-B692-B78767844F4A")]
    public interface IWowLocatorService
    {
        /// <summary>
        /// Gets a value indicting whether a World of Warcraft installation was detected.
        /// </summary>
        bool IsWowInstalled { get; }

        /// <summary>
        /// Gets the base path to the World of Warcraft installation.
        /// </summary>
        /// <returns>The base path to World of Warcraft.</returns>
        string GetWowBasePath();

    	/// <summary>
    	/// Gets the latest World of Warcraft Interface version.
    	/// </summary>
    	/// <returns>The latest World of Warcraft interface version.</returns>
    	string GetWowInterface();
    }
}
