﻿using System;
using Microsoft.Deployment.WindowsInstaller;

namespace Microsoft.WowAddonStudio.Setup.CustomActions 
{
    public class WindowsInstallerSession : ISession
    {
        private readonly Session session;

        public WindowsInstallerSession(Session session)
        {
            if (session == null)
                throw new ArgumentNullException("session");

            this.session = session;
        }

        public void Log(string msg)
        {
            session.Log(msg);
        }

        public void Log(string format, params object[] args)
        {
            session.Log(format, args);
        }

        public void Dispose()
        {
            session.Dispose();
        }
    }
}
