UIObject = {
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
}
FontInstance = {
  ["SetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyV",
    ["signature"] = "FontInstance:SetJustifyV(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "sets the vertical justification.",
  },
  ["GetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowColor",
    ["signature"] = "red, green, blue, alpha = FontInstance:GetShadowColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the color of the font's text shadow.",
  },
  ["GetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyH",
    ["signature"] = "FontInstance:GetJustifyH()",
    ["returns"] = {
    },
    ["desc"] = "Returns the horizontal justification of the text in the FontInstance.",
  },
  ["SetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyH",
    ["signature"] = "FontInstance:SetJustifyH(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the horizontal justification.",
  },
  ["GetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowOffset",
    ["signature"] = "x,y = FontInstance:GetShadowOffset()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's shadow offset.",
  },
  ["SetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTextColor",
    ["signature"] = "FontInstance:SetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Sets the primary (text) color.",
  },
  ["SetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowColor",
    ["signature"] = "FontInstance:SetShadowColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the font's shadow.",
  },
  ["GetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextColor",
    ["signature"] = "r, g, b, a = FontInstance:GetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the default text color for the FontInstance.",
  },
  ["GetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyV",
    ["signature"] = "FontInstance:GetJustifyV()",
    ["returns"] = {
    },
    ["desc"] = "Returns font's vertical justification.",
  },
  ["SetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFont",
    ["signature"] = "FontInstance:SetFont(filename, fontHeight[, flags])",
    ["returns"] = {
    },
    ["desc"] = "Set the font of the font object.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["GetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFont",
    ["signature"] = "fontName, fontHeight, fontFlags = FontInstance:GetFont()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font details of the font instance.",
  },
  ["SetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSpacing",
    ["signature"] = "FontInstance:SetSpacing(spacing)",
    ["returns"] = {
    },
    ["desc"] = "Sets the spacing of the font.",
  },
  ["GetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetSpacing",
    ["signature"] = "FontInstance:GetSpacing()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's spacing.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["GetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFontObject",
    ["signature"] = "FontInstance:GetFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font object used by the font if present. See SetFontObject.",
  },
  ["SetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFontObject",
    ["signature"] = "FontInstance:SetFontObject(font or \"font\" or nil)",
    ["returns"] = {
    },
    ["desc"] = "Set a font object to be used as the current font.",
  },
  ["SetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowOffset",
    ["signature"] = "FontInstance:SetShadowOffset(x, y)",
    ["returns"] = {
    },
    ["desc"] = "Sets the distance to offset the shadow of the text.",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
}
Font = {
  ["SetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyV",
    ["signature"] = "FontInstance:SetJustifyV(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "sets the vertical justification.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["GetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyH",
    ["signature"] = "FontInstance:GetJustifyH()",
    ["returns"] = {
    },
    ["desc"] = "Returns the horizontal justification of the text in the FontInstance.",
  },
  ["GetMultilineIndent"] = {
    ["undocumented"] = true,
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["SetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTextColor",
    ["signature"] = "FontInstance:SetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Sets the primary (text) color.",
  },
  ["SetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowColor",
    ["signature"] = "FontInstance:SetShadowColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the font's shadow.",
  },
  ["GetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowColor",
    ["signature"] = "red, green, blue, alpha = FontInstance:GetShadowColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the color of the font's text shadow.",
  },
  ["GetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextColor",
    ["signature"] = "r, g, b, a = FontInstance:GetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the default text color for the FontInstance.",
  },
  ["SetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFontObject",
    ["signature"] = "FontInstance:SetFontObject(font or \"font\" or nil)",
    ["returns"] = {
    },
    ["desc"] = "Set a font object to be used as the current font.",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "Font:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha (opposite of transparency) for the Font (from 0 to 1).",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "Font:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the alpha (opposite of transparency) for the Font (from 0 to 1).",
  },
  ["GetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyV",
    ["signature"] = "FontInstance:GetJustifyV()",
    ["returns"] = {
    },
    ["desc"] = "Returns font's vertical justification.",
  },
  ["SetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFont",
    ["signature"] = "FontInstance:SetFont(filename, fontHeight[, flags])",
    ["returns"] = {
    },
    ["desc"] = "Set the font of the font object.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["GetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetSpacing",
    ["signature"] = "FontInstance:GetSpacing()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's spacing.",
  },
  ["GetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowOffset",
    ["signature"] = "x,y = FontInstance:GetShadowOffset()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's shadow offset.",
  },
  ["SetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSpacing",
    ["signature"] = "FontInstance:SetSpacing(spacing)",
    ["returns"] = {
    },
    ["desc"] = "Sets the spacing of the font.",
  },
  ["GetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFont",
    ["signature"] = "fontName, fontHeight, fontFlags = FontInstance:GetFont()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font details of the font instance.",
  },
  ["CopyFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "CopyFontObject",
    ["signature"] = "Font:CopyFontObject(font)",
    ["returns"] = {
    },
    ["desc"] = "Copies the settings from the specified font.",
  },
  ["GetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFontObject",
    ["signature"] = "FontInstance:GetFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font object used by the font if present. See SetFontObject.",
  },
  ["SetMultilineIndent"] = {
    ["undocumented"] = true,
  },
  ["SetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowOffset",
    ["signature"] = "FontInstance:SetShadowOffset(x, y)",
    ["returns"] = {
    },
    ["desc"] = "Sets the distance to offset the shadow of the text.",
  },
  ["SetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyH",
    ["signature"] = "FontInstance:SetJustifyH(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the horizontal justification.",
  },
}
Region = {
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
}
VisibleRegion = {
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
}
LayeredRegion = {
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["GetDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "GetDrawLayer",
    ["signature"] = "LayeredRegion:GetDrawLayer()",
    ["returns"] = {
    },
    ["desc"] = "Returns this layered region's draw layer (for example \"BACKGROUND\" and \"ARTWORK\")",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["SetVertexColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetVertexColor",
    ["signature"] = "LayeredRegion:SetVertexColor([r][, g][, b][, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color tint of this layered region to the given percentage values (0.0-1.0), modifying the original texture",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["SetDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "SetDrawLayer",
    ["signature"] = "LayeredRegion:SetDrawLayer(\"layer\")",
    ["returns"] = {
    },
    ["desc"] = "Sets this layered region's draw layer to the given value (for example \"BACKGROUND\" and \"ARTWORK\")",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
}
FontString = {
  ["SetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyV",
    ["signature"] = "FontInstance:SetJustifyV(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "sets the vertical justification.",
  },
  ["SetFormattedText"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFormattedText",
    ["signature"] = "FontString:SetFormattedText(format, ...)",
    ["returns"] = {
    },
    ["desc"] = "Sets the text of the font string widget using the defined format rules.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetText"] = {
    ["arguments"] = {
    },
    ["name"] = "GetText",
    ["signature"] = "FontString:GetText()",
    ["returns"] = {
    },
    ["desc"] = "Returns the text currently set in the font string widget.",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["GetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextColor",
    ["signature"] = "r, g, b, a = FontInstance:GetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the default text color for the FontInstance.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["SetDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "SetDrawLayer",
    ["signature"] = "LayeredRegion:SetDrawLayer(\"layer\")",
    ["returns"] = {
    },
    ["desc"] = "Sets this layered region's draw layer to the given value (for example \"BACKGROUND\" and \"ARTWORK\")",
  },
  ["GetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetSpacing",
    ["signature"] = "FontInstance:GetSpacing()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's spacing.",
  },
  ["GetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyV",
    ["signature"] = "FontInstance:GetJustifyV()",
    ["returns"] = {
    },
    ["desc"] = "Returns font's vertical justification.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["GetDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "GetDrawLayer",
    ["signature"] = "LayeredRegion:GetDrawLayer()",
    ["returns"] = {
    },
    ["desc"] = "Returns this layered region's draw layer (for example \"BACKGROUND\" and \"ARTWORK\")",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["GetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFont",
    ["signature"] = "fontName, fontHeight, fontFlags = FontInstance:GetFont()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font details of the font instance.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["GetStringWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetStringWidth",
    ["signature"] = "FontString:GetStringWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the text displayed on the font string",
  },
  ["SetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowOffset",
    ["signature"] = "FontInstance:SetShadowOffset(x, y)",
    ["returns"] = {
    },
    ["desc"] = "Sets the distance to offset the shadow of the text.",
  },
  ["SetVertexColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetVertexColor",
    ["signature"] = "LayeredRegion:SetVertexColor([r][, g][, b][, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color tint of this layered region to the given percentage values (0.0-1.0), modifying the original texture",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowColor",
    ["signature"] = "red, green, blue, alpha = FontInstance:GetShadowColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the color of the font's text shadow.",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["SetText"] = {
    ["arguments"] = {
    },
    ["name"] = "SetText",
    ["signature"] = "FontString:SetText(\"text\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the text to be displayed in the font string",
  },
  ["GetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyH",
    ["signature"] = "FontInstance:GetJustifyH()",
    ["returns"] = {
    },
    ["desc"] = "Returns the horizontal justification of the text in the FontInstance.",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["SetAlphaGradient"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlphaGradient",
    ["signature"] = "success = FontString:SetAlphaGradient(start, length)",
    ["returns"] = {
    },
    ["desc"] = "Fades the fontstring text out with an alpha gradient, returning 1 if successful and nil otherwise",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["SetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyH",
    ["signature"] = "FontInstance:SetJustifyH(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the horizontal justification.",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowOffset",
    ["signature"] = "x,y = FontInstance:GetShadowOffset()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's shadow offset.",
  },
  ["SetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFont",
    ["signature"] = "FontInstance:SetFont(filename, fontHeight[, flags])",
    ["returns"] = {
    },
    ["desc"] = "Set the font of the font object.",
  },
  ["SetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTextColor",
    ["signature"] = "FontInstance:SetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Sets the primary (text) color.",
  },
  ["SetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowColor",
    ["signature"] = "FontInstance:SetShadowColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the font's shadow.",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["SetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSpacing",
    ["signature"] = "FontInstance:SetSpacing(spacing)",
    ["returns"] = {
    },
    ["desc"] = "Sets the spacing of the font.",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["SetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFontObject",
    ["signature"] = "FontInstance:SetFontObject(font or \"font\" or nil)",
    ["returns"] = {
    },
    ["desc"] = "Set a font object to be used as the current font.",
  },
  ["GetStringHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetStringHeight",
    ["signature"] = "FontString:GetStringHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the text displayed on the font string",
  },
  ["SetMultilineIndent"] = {
    ["undocumented"] = true,
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["GetMultilineIndent"] = {
    ["undocumented"] = true,
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["SetNonSpaceWrap"] = {
    ["arguments"] = {
    },
    ["name"] = "SetNonSpaceWrap",
    ["signature"] = "FontString:SetNonSpaceWrap(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether the FontString will wrap text in the middle of a word.",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["GetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFontObject",
    ["signature"] = "FontInstance:GetFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font object used by the font if present. See SetFontObject.",
  },
  ["CanNonSpaceWrap"] = {
    ["arguments"] = {
    },
    ["name"] = "CanNonSpaceWrap",
    ["signature"] = "FontString:CanNonSpaceWrap()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the FontString will wrap text in the middle of a word.",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["SetTextHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTextHeight",
    ["signature"] = "FontString:SetTextHeight(pixelHeight)",
    ["returns"] = {
    },
    ["desc"] = "Scales the rendered text to the specified height.",
  },
}
Frame = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
}
Texture = {
  ["GetTexCoord"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTexCoord",
    ["signature"] = "minX, maxX, minY, maxY = Texture:GetTexCoord() or ULx, ULy, LLx, LLy, URx, URy, LRx, LRy = Texture:GetTexCoord()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current TexCoord setting for the frame",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["GetTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTexture",
    ["signature"] = "Texture:GetTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the path of the current texture file",
  },
  ["GetDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "GetDrawLayer",
    ["signature"] = "LayeredRegion:GetDrawLayer()",
    ["returns"] = {
    },
    ["desc"] = "Returns this layered region's draw layer (for example \"BACKGROUND\" and \"ARTWORK\")",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetBlendMode"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBlendMode",
    ["signature"] = "Texture:GetBlendMode()",
    ["returns"] = {
      {
        ["name"] = "mode",
        ["type"] = "string",
        ["values"] = {
          ["DISABLE"] = "opaque texture",
          ["MOD"] = "modulating blend",
          ["BLEND"] = "normal painting on top of the background, obeying alpha channels if present in the image",
          ["ADD"] = "additive blend",
          ["ALPHAKEY"] = "one-bit alpha",
        },
        ["desc"] = "The blend mode of the selected texture.",
      },
    },
    ["desc"] = "Return the blend mode of the texture.",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["SetBlendMode"] = {
    ["arguments"] = {
      {
        ["name"] = "mode",
        ["type"] = "string",
        ["values"] = {
          ["DISABLE"] = "opaque texture",
          ["MOD"] = "modulating blend",
          ["BLEND"] = "normal painting on top of the background, obeying alpha channels if present in the image",
          ["ADD"] = "additive blend",
          ["ALPHAKEY"] = "one-bit alpha",
        },
        ["desc"] = "The blend mode of the selected texture.",
      },
    },
    ["name"] = "SetBlendMode",
    ["signature"] = "Texture:SetBlendMode(\"mode\")",
    ["returns"] = {
    },
    ["desc"] = "Set the blend mode of the texture.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["GetVertexColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetVertexColor",
    ["signature"] = "red, green, blue, alpha = Texture:GetVertexColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the vertex color of the texture",
  },
  ["GetTexCoordModifiesRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTexCoordModifiesRect",
    ["signature"] = "Texture:GetTexCoordModifiesRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not TexCoords modify the HitRect",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetRotation"] = {
    ["undocumented"] = true,
  },
  ["SetVertexColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetVertexColor",
    ["signature"] = "LayeredRegion:SetVertexColor([r][, g][, b][, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color tint of this layered region to the given percentage values (0.0-1.0), modifying the original texture",
  },
  ["SetTexCoord"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTexCoord",
    ["signature"] = "Texture:SetTexCoord(minX, maxX, minY, maxY) or SetTexCoord(ULx, ULy, LLx, LLy, URx, URy, LRx, LRy)",
    ["returns"] = {
    },
    ["desc"] = "Sets the corner coordinates for the texture display",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["IsDesaturated"] = {
    ["arguments"] = {
    },
    ["name"] = "IsDesaturated",
    ["signature"] = "Texture:IsDesaturated()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the texture is currently desaturated",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["SetTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTexture",
    ["signature"] = "Texture:SetTexture(texture or \"texture\" or nil)",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture to be displayed on a texture object",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["SetGradient"] = {
    ["arguments"] = {
    },
    ["name"] = "SetGradient",
    ["signature"] = "Texture:SetGradient(\"orientation\", minR, minG, minB, maxR, maxG, maxB)",
    ["returns"] = {
    },
    ["desc"] = "Sets a gradient for the texture",
  },
  ["SetGradientAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetGradientAlpha",
    ["signature"] = "Texture:SetGradientAlpha(\"orientation\", minR, minG, minB, minA, maxR, maxG, maxB, maxA)",
    ["returns"] = {
    },
    ["desc"] = "Sets a gradient for the texture, with alpha values",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["SetTexCoordModifiesRect"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTexCoordModifiesRect",
    ["signature"] = "Texture:SetTexCoordModifiesRect(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the TexCoords for the texture modified the HitRect",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["SetDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "SetDrawLayer",
    ["signature"] = "LayeredRegion:SetDrawLayer(\"layer\")",
    ["returns"] = {
    },
    ["desc"] = "Sets this layered region's draw layer to the given value (for example \"BACKGROUND\" and \"ARTWORK\")",
  },
  ["SetDesaturated"] = {
    ["arguments"] = {
    },
    ["name"] = "SetDesaturated",
    ["signature"] = "supported = Texture:SetDesaturated()",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the function should be displayed with no saturation",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
}
GameTooltip = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["SetHyperlink"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHyperlink",
    ["signature"] = "GameTooltip:SetHyperlink(itemLink)",
    ["returns"] = {
    },
    ["desc"] = "Sets the GameTooltip to show the item indicated by the itemLink.  Calling too many items that have not been seen on the server yet will disconnect you.",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetLootItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetLootItem",
    ["signature"] = "GameTooltip:SetLootItem(index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the GameTooltip to show the item at the given index",
  },
  ["GetSpell"] = {
    ["arguments"] = {
    },
    ["name"] = "GetSpell",
    ["signature"] = "name, rank = GameTooltip:GetSpell()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name and rank of the spell currently being displayed",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["SetMerchantItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMerchantItem",
    ["signature"] = "GameTooltip:SetMerchantItem(index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip to the specified merchant's item index.",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["SetInventoryItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetInventoryItem",
    ["signature"] = "GameTooltip:SetInventoryItem(unit, slot [, nameOnly])",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip to the specified slot on the specified unit.",
  },
  ["GetAnchorType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAnchorType",
    ["signature"] = "GameTooltip:GetAnchorType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current anchor type",
  },
  ["SetAuctionSellItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAuctionSellItem",
    ["signature"] = "GameTooltip:SetAuctionSellItem()",
    ["returns"] = {
    },
    ["desc"] = "Sets teh tooltip for the item currently set to be auctioned.",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["SetShapeshift"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShapeshift",
    ["signature"] = "GameTooltip:SetShapeshift(index)",
    ["returns"] = {
    },
    ["desc"] = "Displays the spell tooltip for the shapeshift spell with the given index",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetSocketedItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSocketedItem",
    ["signature"] = "GameTooltip:SetSocketedItem()",
    ["returns"] = {
    },
    ["desc"] = "Displays the item tooltip for the item currently being socketed with gems",
  },
  ["SetUnitDebuff"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUnitDebuff",
    ["signature"] = "GameTooltip:SetUnitDebuff(\"unit\", debuffIndex[, dispelFilter])",
    ["returns"] = {
    },
    ["desc"] = "Sets this tooltip to show the given unit and debuff index's debuff name and description, optionally filtered to only show buffs you can dispel",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["AddDoubleLine"] = {
    ["arguments"] = {
    },
    ["name"] = "AddDoubleLine",
    ["signature"] = "GameTooltip:AddDoubleLine(\"textLeft\", \"textRight\" [, rL, gL, bL [, rR, gR, bR]])",
    ["returns"] = {
    },
    ["desc"] = "Adds a line to the tooltip with both a left and a right component",
  },
  ["SetGlyph"] = {
    ["undocumented"] = true,
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["SetTrainerService"] = {
    ["arguments"] = {
      {
        ["type"] = "number",
        ["name"] = "index",
        ["desc"] = "The index of the row who's information you want presented in the tooltip",
      },
    },
    ["name"] = "SetTrainerService",
    ["signature"] = "GameTooltip:SetTrainerService(index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip for a trainable spell at a trainer",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["SetHyperlinkCompareItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHyperlinkCompareItem",
    ["signature"] = "success = GameTooltip:SetHyperlinkCompareItem(\"itemLink\" [, index])",
    ["returns"] = {
    },
    ["desc"] = "Displays the item tooltip for the item currently equipped in the same slot as the given item link. Returns 1 if the action succeeds, nil otherwise",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["AddFontStrings"] = {
    ["arguments"] = {
    },
    ["name"] = "AddFontStrings",
    ["signature"] = "GameTooltip:AddFontStrings(leftstring, rightstring)",
    ["returns"] = {
    },
    ["desc"] = "Adds fontstrings to the tooltip, dynamically expanding the number of lines",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["SetMinimumWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinimumWidth",
    ["signature"] = "GameTooltip:SetMinimumWidth(width[, force])",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum width of the tooltip to the given value.",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["SetText"] = {
    ["arguments"] = {
    },
    ["name"] = "SetText",
    ["signature"] = "GameTooltip:SetText(text)",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip to read just the text sent to this function.",
  },
  ["SetExistingSocketGem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetExistingSocketGem",
    ["signature"] = "GameTooltip:SetExistingSocketGem(gemIndex [, toDestroy])",
    ["returns"] = {
    },
    ["desc"] = "Displays the item tooltip of the given gem already socketed in a socket in the gem socketing frame",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["SetTradeSkillItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTradeSkillItem",
    ["signature"] = "GameTooltip:SetTradeSkillItem(tradeskillIndex[, reagentIndex])",
    ["returns"] = {
    },
    ["desc"] = "Displays the given tradeskill item in the tooltip, or optionally a reagent of the given tradeskill item instead",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["NumLines"] = {
    ["arguments"] = {
    },
    ["name"] = "NumLines",
    ["signature"] = "GameTooltip:NumLines()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of lines in the tooltip object",
  },
  ["GetUnit"] = {
    ["arguments"] = {
    },
    ["name"] = "GetUnit",
    ["signature"] = "unitName, unitId = GameTooltip:GetUnit()",
    ["returns"] = {
    },
    ["desc"] = "Returns the unit the tooltip is currently displaying information for",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["SetBuybackItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBuybackItem",
    ["signature"] = "GameTooltip:SetBuybackItem(slot)",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip to the specified merchant buyback item.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["SetBagItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBagItem",
    ["signature"] = "hasCooldown, repairCost = GameTooltip:SetBagItem(bag,item)",
    ["returns"] = {
    },
    ["desc"] = "Sets the GameTooltip to show the item from the given bag and slot",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["SetMerchantCostItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMerchantCostItem",
    ["signature"] = "GameTooltip:SetMerchantCostItem(merchantIndex, itemCostIndex)",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip for the item cost of a specific item.",
  },
  ["SetAnchorType"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAnchorType",
    ["signature"] = "GameTooltip:SetAnchorType(\"anchorType\"[, xOffset][, yOffset])",
    ["returns"] = {
    },
    ["desc"] = "Changes the anchor point for the tooltip relative to its owner, optionally with offsets. See GameTooltip:SetOwner() for valid anchor types.",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["SetTalent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTalent",
    ["signature"] = "GameTooltip:SetTalent(tabIndex, talentIndex [,isInspect])",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip description for the specified talent.",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["SetLootRollItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetLootRollItem",
    ["signature"] = "GameTooltip:SetLootRollItem(id)",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip for the selected loot roll item.",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetOwner"] = {
    ["arguments"] = {
    },
    ["name"] = "SetOwner",
    ["signature"] = "GameTooltip:SetOwner(frame [, \"anchorType\"][, xOffset][, yOffset])",
    ["returns"] = {
    },
    ["desc"] = "Sets the owner of the tooltip, modifying parent and anchor points",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["SetSocketGem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSocketGem",
    ["signature"] = "GameTooltip:SetSocketGem(gemIndex)",
    ["returns"] = {
    },
    ["desc"] = "Displays the item tooltip of the given gem to be socketed in a socket in the gem socketing frame",
  },
  ["SetAction"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAction",
    ["signature"] = "GameTooltip:SetAction(slot)",
    ["returns"] = {
    },
    ["desc"] = "Sets the GameTooltip to show the statistics for the action at the given slot",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["SetTradeTargetItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTradeTargetItem",
    ["signature"] = "GameTooltip:SetTradeTargetItem(itemIndex)",
    ["returns"] = {
    },
    ["desc"] = "Displays the item tooltip for the given item index in your trade",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["SetSpell"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSpell",
    ["signature"] = "GameTooltip:SetSpell(spellID,bookType)",
    ["returns"] = {
    },
    ["desc"] = "Sets the GameTooltip to show a spell from the spellbook",
  },
  ["AddTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "AddTexture",
    ["signature"] = "GameTooltip:AddTexture()",
    ["returns"] = {
    },
    ["desc"] = "Adds a texture to the beginning of the last tooltip line added",
  },
  ["GetOwner"] = {
    ["arguments"] = {
    },
    ["name"] = "GetOwner",
    ["signature"] = "GameTooltip:GetOwner()",
    ["returns"] = {
    },
    ["desc"] = "Returns the owner of the tooltip",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["SetCurrencyToken"] = {
    ["undocumented"] = true,
  },
  ["SetGuildBankItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetGuildBankItem",
    ["signature"] = "GameTooltip:SetGuildBankItem(tab, itemIndex)",
    ["returns"] = {
    },
    ["desc"] = "Displays the item tooltip for the given guild bank tab and item index",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetPadding"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPadding",
    ["signature"] = "GameTooltip:SetPadding(amount)",
    ["returns"] = {
    },
    ["desc"] = "Sets the padding on the right side of the tooltip.",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["SetQuestRewardSpell"] = {
    ["arguments"] = {
    },
    ["name"] = "SetQuestRewardSpell",
    ["signature"] = "GameTooltip:SetQuestRewardSpell()",
    ["returns"] = {
    },
    ["desc"] = "Displays the spell tooltip of the spell you will receive when completing the currently active quest at a quest NPC",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["SetTracking"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTracking",
    ["signature"] = "GameTooltip:SetTracking()",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip to a description of the current tracking type or \"Click to choose tracking type\" if no tracking type is selected",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["ClearLines"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearLines",
    ["signature"] = "GameTooltip:ClearLines()",
    ["returns"] = {
    },
    ["desc"] = "Clears the lines of the tooltip",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["AddLine"] = {
    ["arguments"] = {
    },
    ["name"] = "AddLine",
    ["signature"] = "GameTooltip:AddLine(text [, red, green, blue [, wrapFlag]])",
    ["returns"] = {
    },
    ["desc"] = "Adds a line to the tooltip with optional color",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["SetPetAction"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPetAction",
    ["signature"] = "GameTooltip:SetPetAction(slot)",
    ["returns"] = {
    },
    ["desc"] = "Sets the GameTooltip to show the statistics for the given pet action slot",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetQuestItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetQuestItem",
    ["signature"] = "GameTooltip:SetQuestItem(\"type\", index)",
    ["returns"] = {
    },
    ["desc"] = "Displays the item tooltip for the given type and index",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["SetQuestLogRewardSpell"] = {
    ["arguments"] = {
    },
    ["name"] = "SetQuestLogRewardSpell",
    ["signature"] = "GameTooltip:SetQuestLogRewardSpell()",
    ["returns"] = {
    },
    ["desc"] = "Displays the spell tooltip of the spell you will receive when completing the selected quest in the quest log",
  },
  ["SetUnitAura"] = {
    ["undocumented"] = true,
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["SetInboxItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetInboxItem",
    ["signature"] = "GameTooltip:SetInboxItem(messageIndex, attachmentIndex)",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip of the specified inbox item of the specified mail message.",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["SetTotem"] = {
    ["undocumented"] = true,
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["SetPossession"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPossession",
    ["signature"] = "GameTooltip:SetPossession(slot)",
    ["returns"] = {
    },
    ["desc"] = "Displays the tooltip for the possession bar slots",
  },
  ["SetQuestLogItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetQuestLogItem",
    ["signature"] = "GameTooltip:SetQuestLogItem(index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip to a quest log item reward by index",
  },
  ["SetBackpackToken"] = {
    ["undocumented"] = true,
  },
  ["SetUnitBuff"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUnitBuff",
    ["signature"] = "GameTooltip:SetUnitBuff(\"unit\", buffIndex [, castFilter])",
    ["returns"] = {
    },
    ["desc"] = "Sets this tooltip to show the given unit and buff index's buff name and description, optionally filtered to only show buffs you can cast",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["SetTradePlayerItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTradePlayerItem",
    ["signature"] = "GameTooltip:SetTradePlayerItem(itemIndex)",
    ["returns"] = {
    },
    ["desc"] = "Displays the item tooltip for the given item index in your trade",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["SetSendMailItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSendMailItem",
    ["signature"] = "GameTooltip:SetSendMailItem(index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the GameTooltip to the item at the given attachment index in the send mail interface",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["IsOwned"] = {
    ["arguments"] = {
    },
    ["name"] = "IsOwned",
    ["signature"] = "GameTooltip:IsOwned(frame)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the tooltip is owned",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["IsUnit"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUnit",
    ["signature"] = "GameTooltip:IsUnit(\"unit\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the tooltip is currently displaying the given unit's information",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["SetAuctionItem"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAuctionItem",
    ["signature"] = "GameTooltip:SetAuctionItem(\"type\", index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the tooltip to the specified index in the specified auction house listing.",
  },
  ["GetMinimumWidth"] = {
    ["undocumented"] = true,
  },
  ["SetUnit"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUnit",
    ["signature"] = "GameTooltip:SetUnit(\"unit\" or \"unitName\")",
    ["returns"] = {
    },
    ["desc"] = "Displays the mouseover tooltip for the given unit in this tooltip",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["FadeOut"] = {
    ["arguments"] = {
    },
    ["name"] = "FadeOut",
    ["signature"] = "GameTooltip:FadeOut()",
    ["returns"] = {
    },
    ["desc"] = "Causes the tooltip to begin fading out",
  },
  ["GetItem"] = {
    ["arguments"] = {
    },
    ["name"] = "GetItem",
    ["signature"] = "name, link = GameTooltip:GetItem()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name and the link of the item being displayed in the tooltip",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["AppendText"] = {
    ["arguments"] = {
    },
    ["name"] = "AppendText",
    ["signature"] = "GameTooltip:AppendText(\"text\")",
    ["returns"] = {
    },
    ["desc"] = "Adds text to the first line of the tooltip",
  },
}
EditBox = {
  ["SetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyV",
    ["signature"] = "FontInstance:SetJustifyV(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "sets the vertical justification.",
  },
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["IsInIMECompositionMode"] = {
    ["arguments"] = {
    },
    ["name"] = "IsInIMECompositionMode",
    ["signature"] = "EditBox:IsInIMECompositionMode()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the EditBox is in IME composition mode.",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetIndentedWordWrap"] = {
    ["undocumented"] = true,
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["GetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyV",
    ["signature"] = "FontInstance:GetJustifyV()",
    ["returns"] = {
    },
    ["desc"] = "Returns font's vertical justification.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["GetIndentedWordWrap"] = {
    ["undocumented"] = true,
  },
  ["GetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFont",
    ["signature"] = "fontName, fontHeight, fontFlags = FontInstance:GetFont()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font details of the font instance.",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["SetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFontObject",
    ["signature"] = "FontInstance:SetFontObject(font or \"font\" or nil)",
    ["returns"] = {
    },
    ["desc"] = "Set a font object to be used as the current font.",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["AddHistoryLine"] = {
    ["arguments"] = {
      {
        ["type"] = "string",
        ["name"] = "text",
        ["desc"] = "The text you wish to add",
      },
    },
    ["name"] = "AddHistoryLine",
    ["signature"] = "EditBox:AddHistoryLine(\"text\")",
    ["returns"] = {
    },
    ["desc"] = "Adds a line of text to an edit box's history.",
  },
  ["HighlightText"] = {
    ["arguments"] = {
    },
    ["name"] = "HighlightText",
    ["signature"] = "EditBox:HighlightText([start [,end]])",
    ["returns"] = {
    },
    ["desc"] = "Highlights the selected text in the editbox.",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["GetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFontObject",
    ["signature"] = "FontInstance:GetFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font object used by the font if present. See SetFontObject.",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["GetBlinkSpeed"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBlinkSpeed",
    ["signature"] = "EditBox:GetBlinkSpeed()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "speed",
        ["desc"] = "The blink speed, in seconds.",
      },
    },
    ["desc"] = "Returns the cursor's blink speed.",
  },
  ["SetMaxLetters"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxLetters",
    ["signature"] = "EditBox:SetMaxLetters(max)",
    ["returns"] = {
    },
    ["desc"] = "Set the maximum number of letters allowed in the editbox.",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["SetBlinkSpeed"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBlinkSpeed",
    ["signature"] = "EditBox:SetBlinkSpeed(speed)",
    ["returns"] = {
    },
    ["desc"] = "Sets the blink rate for the cursor.",
  },
  ["GetMaxLetters"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxLetters",
    ["signature"] = "EditBox:GetMaxLetters()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum number of letters you can enter into an EditBox.",
  },
  ["GetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetSpacing",
    ["signature"] = "FontInstance:GetSpacing()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's spacing.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSpacing",
    ["signature"] = "FontInstance:SetSpacing(spacing)",
    ["returns"] = {
    },
    ["desc"] = "Sets the spacing of the font.",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetAutoFocus"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAutoFocus",
    ["signature"] = "EditBox:SetAutoFocus(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the edit box will automatically acquire cursor focus",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["SetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowColor",
    ["signature"] = "FontInstance:SetShadowColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the font's shadow.",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["GetHistoryLines"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHistoryLines",
    ["signature"] = "EditBox:GetHistoryLines()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "count",
        ["desc"] = "The max number of history lines.",
      },
    },
    ["desc"] = "Returns the max number of history lines.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["HasFocus"] = {
    ["arguments"] = {
    },
    ["name"] = "HasFocus",
    ["signature"] = "hasFocus = EditBox:HasFocus()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the EditBox has the keyboard cursor focus.",
  },
  ["GetText"] = {
    ["arguments"] = {
    },
    ["name"] = "GetText",
    ["signature"] = "EditBox:GetText()",
    ["returns"] = {
    },
    ["desc"] = "Retreives the text stored in the EditBox.",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowOffset",
    ["signature"] = "FontInstance:SetShadowOffset(x, y)",
    ["returns"] = {
    },
    ["desc"] = "Sets the distance to offset the shadow of the text.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["GetInputLanguage"] = {
    ["arguments"] = {
    },
    ["name"] = "GetInputLanguage",
    ["signature"] = "EditBox:GetInputLanguage()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current input language charset selected.",
  },
  ["SetMultiLine"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMultiLine",
    ["signature"] = "EditBox:SetMultiLine(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets the EditBox to use multiple lines of text.",
  },
  ["SetCursorPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "SetCursorPosition",
    ["signature"] = "EditBox:SetCursorPosition(position)",
    ["returns"] = {
    },
    ["desc"] = "Sets the cursor position in the editbox",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["IsPassword"] = {
    ["arguments"] = {
    },
    ["name"] = "IsPassword",
    ["signature"] = "EditBox:IsPassword()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the EditBox is in password mode.",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["IsAutoFocus"] = {
    ["arguments"] = {
    },
    ["name"] = "IsAutoFocus",
    ["signature"] = "EditBox:IsAutoFocus()",
    ["returns"] = {
    },
    ["desc"] = "Returns true if the EditBox will automatically grab keyboard focus when it is shown.",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["SetNumeric"] = {
    ["arguments"] = {
    },
    ["name"] = "SetNumeric",
    ["signature"] = "EditBox:SetNumeric(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether the edit box should only accept numbers.",
  },
  ["ClearFocus"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearFocus",
    ["signature"] = "EditBox:ClearFocus()",
    ["returns"] = {
    },
    ["desc"] = "Clears the input focus from an edit box.",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetTextInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextInsets",
    ["signature"] = "left, right, top, bottom = EditBox:GetTextInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance between the edges of the EditBox and the text inside it.",
  },
  ["SetAltArrowKeyMode"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAltArrowKeyMode",
    ["signature"] = "EditBox:SetAltArrowKeyMode(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets the EditBox to ignore arrow keys unless you hold ALT.",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["GetNumLetters"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumLetters",
    ["signature"] = "EditBox:GetNumLetters()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of letters in the editbox.",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["GetAltArrowKeyMode"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAltArrowKeyMode",
    ["signature"] = "EditBox:GetAltArrowKeyMode()",
    ["returns"] = {
      {
        ["type"] = "1nil",
        ["name"] = "state",
        ["desc"] = "The state the edit box is in.",
      },
    },
    ["desc"] = "Returns the arrow key mode state.",
  },
  ["SetTextInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTextInsets",
    ["signature"] = "EditBox:SetTextInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the padding between the edges of the edit box and its text.",
  },
  ["IsNumeric"] = {
    ["arguments"] = {
    },
    ["name"] = "IsNumeric",
    ["signature"] = "EditBox:IsNumeric()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the EditBox is in numeric mode. See SetNumeric.",
  },
  ["SetFocus"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFocus",
    ["signature"] = "EditBox:SetFocus()",
    ["returns"] = {
    },
    ["desc"] = "Gives the EditBox keyboard cursor focus.",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["GetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextColor",
    ["signature"] = "r, g, b, a = FontInstance:GetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the default text color for the FontInstance.",
  },
  ["ToggleInputLanguage"] = {
    ["arguments"] = {
    },
    ["name"] = "ToggleInputLanguage",
    ["signature"] = "EditBox:ToggleInputLanguage()",
    ["returns"] = {
    },
    ["desc"] = "Toggles the input language for the EditBox.",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["SetMaxBytes"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxBytes",
    ["signature"] = "EditBox:SetMaxBytes(max)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum number of bytes to display in the editbox",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["GetMaxBytes"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxBytes",
    ["signature"] = "EditBox:GetMaxBytes()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum number of bytes allowed in the edit box.",
  },
  ["SetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFont",
    ["signature"] = "FontInstance:SetFont(filename, fontHeight[, flags])",
    ["returns"] = {
    },
    ["desc"] = "Set the font of the font object.",
  },
  ["GetCursorPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCursorPosition",
    ["signature"] = "EditBox:GetCursorPosition()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "position",
        ["desc"] = "The position of the cursor",
      },
    },
    ["desc"] = "Returns the current cursor position inside a given edit box.",
  },
  ["GetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowOffset",
    ["signature"] = "x,y = FontInstance:GetShadowOffset()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's shadow offset.",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["GetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowColor",
    ["signature"] = "red, green, blue, alpha = FontInstance:GetShadowColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the color of the font's text shadow.",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["GetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyH",
    ["signature"] = "FontInstance:GetJustifyH()",
    ["returns"] = {
    },
    ["desc"] = "Returns the horizontal justification of the text in the FontInstance.",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["SetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyH",
    ["signature"] = "FontInstance:SetJustifyH(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the horizontal justification.",
  },
  ["SetText"] = {
    ["arguments"] = {
    },
    ["name"] = "SetText",
    ["signature"] = "EditBox:SetText(text)",
    ["returns"] = {
    },
    ["desc"] = "Sets the contents of the EditBox to text. This fires the OnTextChanged handler.",
  },
  ["IsMultiLine"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMultiLine",
    ["signature"] = "EditBox:IsMultiLine()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the EditBox uses more than one line of text.",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["SetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTextColor",
    ["signature"] = "FontInstance:SetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Sets the primary (text) color.",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["Insert"] = {
    ["arguments"] = {
    },
    ["name"] = "Insert",
    ["signature"] = "EditBox:Insert(text)",
    ["returns"] = {
    },
    ["desc"] = "Inserts text into the EditBox at the current cursor position.",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["SetHistoryLines"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHistoryLines",
    ["signature"] = "EditBox:SetHistoryLines(numLines)",
    ["returns"] = {
    },
    ["desc"] = "Sets the number of history lines to store for the EditBox.",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["SetPassword"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPassword",
    ["signature"] = "EditBox:SetPassword(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets the editbox into password mode - masking all input.",
  },
  ["SetNumber"] = {
    ["arguments"] = {
    },
    ["name"] = "SetNumber",
    ["signature"] = "EditBox:SetNumber(number)",
    ["returns"] = {
    },
    ["desc"] = "Set the contents of the editbox to the specified number.",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["GetNumber"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumber",
    ["signature"] = "EditBox:GetNumber()",
    ["returns"] = {
    },
    ["desc"] = "Returns the contents of the editbox converted to a number.",
  },
}
MessageFrame = {
  ["SetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyV",
    ["signature"] = "FontInstance:SetJustifyV(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "sets the vertical justification.",
  },
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetFading"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFading",
    ["signature"] = "MessageFrame:GetFading()",
    ["returns"] = {
      {
        ["type"] = "1nil",
        ["name"] = "doMessagesFade",
        ["desc"] = "1 if the messages will fade, nil if they will always be shown",
      },
    },
    ["desc"] = "Returns 1 when the messages in the MessageFrame fade out after a certain ammount of time, nil otherwise",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetIndentedWordWrap"] = {
    ["undocumented"] = true,
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["GetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyV",
    ["signature"] = "FontInstance:GetJustifyV()",
    ["returns"] = {
    },
    ["desc"] = "Returns font's vertical justification.",
  },
  ["SetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFont",
    ["signature"] = "FontInstance:SetFont(filename, fontHeight[, flags])",
    ["returns"] = {
    },
    ["desc"] = "Set the font of the font object.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["GetIndentedWordWrap"] = {
    ["undocumented"] = true,
  },
  ["GetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFont",
    ["signature"] = "fontName, fontHeight, fontFlags = FontInstance:GetFont()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font details of the font instance.",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["SetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFontObject",
    ["signature"] = "FontInstance:SetFontObject(font or \"font\" or nil)",
    ["returns"] = {
    },
    ["desc"] = "Set a font object to be used as the current font.",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["GetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFontObject",
    ["signature"] = "FontInstance:GetFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font object used by the font if present. See SetFontObject.",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["GetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetSpacing",
    ["signature"] = "FontInstance:GetSpacing()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's spacing.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSpacing",
    ["signature"] = "FontInstance:SetSpacing(spacing)",
    ["returns"] = {
    },
    ["desc"] = "Sets the spacing of the font.",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["AddMessage"] = {
    ["arguments"] = {
    },
    ["name"] = "AddMessage",
    ["signature"] = "MessageFrame:AddMessage(message [, r, g, b])",
    ["returns"] = {
    },
    ["desc"] = "Adds a message to this messageframe, optionally with specified colors",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowColor",
    ["signature"] = "red, green, blue, alpha = FontInstance:GetShadowColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the color of the font's text shadow.",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["SetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowColor",
    ["signature"] = "FontInstance:SetShadowColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the font's shadow.",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["SetFading"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFading",
    ["signature"] = "MessageFrame:SetFading(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables message fading for the MessageFrame.",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["GetInsertMode"] = {
    ["arguments"] = {
    },
    ["name"] = "GetInsertMode",
    ["signature"] = "MessageFrame:GetInsertMode()",
    ["returns"] = {
    },
    ["desc"] = "Returns where messages are inserted for this messageframe, i.e. \"TOP\" or \"BOTTOM\"",
  },
  ["SetTimeVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTimeVisible",
    ["signature"] = "MessageFrame:SetTimeVisible(seconds)",
    ["returns"] = {
    },
    ["desc"] = "Sets the amount of time that individual messages will remain visible.",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetTimeVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTimeVisible",
    ["signature"] = "MessageFrame:GetTimeVisible()",
    ["returns"] = {
      ["type"] = "number",
      ["name"] = "visibleTime",
      ["desc"] = "The time in seconds that a message will stay visible",
    },
    ["desc"] = "Returns the time in seconds that a message sent to this MessageFrame will stay visible before starting to fade.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowOffset",
    ["signature"] = "FontInstance:SetShadowOffset(x, y)",
    ["returns"] = {
    },
    ["desc"] = "Sets the distance to offset the shadow of the text.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["SetInsertMode"] = {
    ["arguments"] = {
    },
    ["name"] = "SetInsertMode",
    ["signature"] = "MessageFrame:SetInsertMode(position)",
    ["returns"] = {
    },
    ["desc"] = "Sets the insertion mode for new messages in the frame (\"TOP\" or \"BOTTOM\").",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["GetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextColor",
    ["signature"] = "r, g, b, a = FontInstance:GetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the default text color for the FontInstance.",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["Clear"] = {
    ["arguments"] = {
    },
    ["name"] = "Clear",
    ["signature"] = "MessageFrame:Clear()",
    ["returns"] = {
    },
    ["desc"] = "Clears all messages from the MessageFrame.",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["GetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyH",
    ["signature"] = "FontInstance:GetJustifyH()",
    ["returns"] = {
    },
    ["desc"] = "Returns the horizontal justification of the text in the FontInstance.",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["SetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyH",
    ["signature"] = "FontInstance:SetJustifyH(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the horizontal justification.",
  },
  ["SetFadeDuration"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFadeDuration",
    ["signature"] = "MessageFrame:SetFadeDuration(seconds)",
    ["returns"] = {
    },
    ["desc"] = "Sets the amount of time before a new message will fade out.",
  },
  ["GetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowOffset",
    ["signature"] = "x,y = FontInstance:GetShadowOffset()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's shadow offset.",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["SetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTextColor",
    ["signature"] = "FontInstance:SetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Sets the primary (text) color.",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["GetFadeDuration"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFadeDuration",
    ["signature"] = "MessageFrame:GetFadeDuration()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current fade duration for the message frame",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
}
Cooldown = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["SetReverse"] = {
    ["arguments"] = {
      {
        ["type"] = "boolean",
        ["name"] = "reverse",
        ["desc"] = "",
      },
    },
    ["name"] = "SetReverse",
    ["signature"] = "Cooldown:SetReverse(reverse)",
    ["returns"] = {
    },
    ["desc"] = "Sets the cooldown model to be animated in reverse.",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["SetCooldown"] = {
    ["arguments"] = {
    },
    ["name"] = "SetCooldown",
    ["signature"] = "Cooldown:SetCooldown(start, duration)",
    ["returns"] = {
    },
    ["desc"] = "Sets up the parameters for a Cooldown model.",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
}
Model = {
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["GetModel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetModel",
    ["signature"] = "Model:GetModel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the file name currently used by the model.",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetSequence"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSequence",
    ["signature"] = "Model:SetSequence(sequence)",
    ["returns"] = {
    },
    ["desc"] = "Sets the model to use the specified animation sequence.",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetFogFar"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogFar",
    ["signature"] = "Model:GetFogFar()",
    ["returns"] = {
    },
    ["desc"] = "Returns the far clipping distance for the model's fog.",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["ClearModel"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearModel",
    ["signature"] = "Model:ClearModel()",
    ["returns"] = {
    },
    ["desc"] = "Removes the current mesh from the Model object.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["GetLight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLight",
    ["signature"] = "... = Model:GetLight()",
    ["returns"] = {
    },
    ["desc"] = "Returns information about the light source used when rendering the model",
  },
  ["ReplaceIconTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "ReplaceIconTexture",
    ["signature"] = "Model:ReplaceIconTexture(path)",
    ["returns"] = {
    },
    ["desc"] = "Sets the icon texture path used by the model.",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["SetFogFar"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogFar",
    ["signature"] = "Model:SetFogFar(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the far clipping distance for the model's fog.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetModelScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetModelScale",
    ["signature"] = "Model:GetModelScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the mesh displayed by the Model",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["SetModelScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetModelScale",
    ["signature"] = "Model:SetModelScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the mesh displayed by the Model.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["SetCamera"] = {
    ["arguments"] = {
    },
    ["name"] = "SetCamera",
    ["signature"] = "Model:SetCamera(index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the pre-defined camera view for the model.",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["SetModel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetModel",
    ["signature"] = "Model:SetModel(filename)",
    ["returns"] = {
    },
    ["desc"] = "Sets the model to the specified file.",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetGlow"] = {
    ["undocumented"] = true,
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["SetFogNear"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogNear",
    ["signature"] = "Model:SetFogNear(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the near clipping distance for the model's fog.",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["AdvanceTime"] = {
    ["arguments"] = {
    },
    ["name"] = "AdvanceTime",
    ["signature"] = "Model:AdvanceTime()",
    ["returns"] = {
    },
    ["desc"] = "Advances to the next animation frame for the model.",
  },
  ["SetFogColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogColor",
    ["signature"] = "Model:SetFogColor(r, g, b[, a])",
    ["returns"] = {
    },
    ["desc"] = "Sets the fog color and enables fog display for the model.",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["GetFogNear"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogNear",
    ["signature"] = "Model:GetFogNear()",
    ["returns"] = {
    },
    ["desc"] = "Returns the near clipping distance for the model's fog.",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["SetPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPosition",
    ["signature"] = "Model:SetPosition(x, y, z)",
    ["returns"] = {
    },
    ["desc"] = "Sets the position of the mesh displayed by the Model.",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["GetFacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFacing",
    ["signature"] = "Model:GetFacing()",
    ["returns"] = {
    },
    ["desc"] = "Gets the current rotation angle of the model in radians.",
  },
  ["SetLight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetLight",
    ["signature"] = "Model:SetLight(enabled[, omni, dirX, dirY, dirZ, ambIntensity[, ambR, ambG, ambB], dirIntensity[, dirR, dirG, dirB]])",
    ["returns"] = {
    },
    ["desc"] = "Sets the origin of the lightsource for rendering of the model",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["ClearFog"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearFog",
    ["signature"] = "Model:ClearFog()",
    ["returns"] = {
    },
    ["desc"] = "Disables fog display for the model.",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["GetFogColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogColor",
    ["signature"] = "r, g, b, a = Model:GetFogColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current fog color for the Model.",
  },
  ["SetSequenceTime"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSequenceTime",
    ["signature"] = "Model:SetSequenceTime(sequence, time)",
    ["returns"] = {
    },
    ["desc"] = "Sets the animation sequence and time index for the Model.",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["GetPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPosition",
    ["signature"] = "x, y, z = Model:GetPosition()",
    ["returns"] = {
    },
    ["desc"] = "Returns the position of the mesh displayed by the Model object.",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["SetFacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFacing",
    ["signature"] = "Model:SetFacing(facing)",
    ["returns"] = {
    },
    ["desc"] = "Gets the current rotation angle of the model in radians.",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
}
Slider = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["SetThumbTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "SetThumbTexture",
    ["signature"] = "Slider:SetThumbTexture(texture or \"texture\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the thumb texture for the slider",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["IsEnabled"] = {
    ["undocumented"] = true,
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetMinMaxValues"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinMaxValues",
    ["signature"] = "min, max = Slider:GetMinMaxValues()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum and maximum values for the slider",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["GetThumbTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetThumbTexture",
    ["signature"] = "Slider:GetThumbTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the thumb texture for the slider",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["SetOrientation"] = {
    ["arguments"] = {
    },
    ["name"] = "SetOrientation",
    ["signature"] = "Slider:SetOrientation(\"orientation\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the orientation of the slider",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["Enable"] = {
    ["undocumented"] = true,
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["SetMinMaxValues"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinMaxValues",
    ["signature"] = "Slider:SetMinMaxValues(min, max)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum and maximum values for the slider",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["Disable"] = {
    ["undocumented"] = true,
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetValueStep"] = {
    ["arguments"] = {
    },
    ["name"] = "SetValueStep",
    ["signature"] = "Slider:SetValueStep(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the step value for the slider",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["GetOrientation"] = {
    ["arguments"] = {
    },
    ["name"] = "GetOrientation",
    ["signature"] = "Slider:GetOrientation()",
    ["returns"] = {
    },
    ["desc"] = "Returns the orientation of the slider",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetValue"] = {
    ["arguments"] = {
    },
    ["name"] = "GetValue",
    ["signature"] = "Slider:GetValue()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current value of the slider",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["GetValueStep"] = {
    ["arguments"] = {
    },
    ["name"] = "GetValueStep",
    ["signature"] = "Slider:GetValueStep()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current step value for the slider",
  },
  ["SetValue"] = {
    ["arguments"] = {
    },
    ["name"] = "SetValue",
    ["signature"] = "Slider:SetValue(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the value of the slider",
  },
}
ScrollFrame = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["SetHorizontalScroll"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHorizontalScroll",
    ["signature"] = "ScrollFrame:SetHorizontalScroll(offset)",
    ["returns"] = {
    },
    ["desc"] = "Sets the horizontal scroll offset",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetHorizontalScrollRange"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHorizontalScrollRange",
    ["signature"] = "ScrollFrame:GetHorizontalScrollRange()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum horizontal scroll offset",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetHorizontalScroll"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHorizontalScroll",
    ["signature"] = "ScrollFrame:GetHorizontalScroll()",
    ["returns"] = {
    },
    ["desc"] = "Returns the horizontal scroll offset",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetVerticalScrollRange"] = {
    ["arguments"] = {
    },
    ["name"] = "GetVerticalScrollRange",
    ["signature"] = "ScrollFrame:GetVerticalScrollRange()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum vertical scroll offset",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["GetVerticalScroll"] = {
    ["arguments"] = {
    },
    ["name"] = "GetVerticalScroll",
    ["signature"] = "ScrollFrame:GetVerticalScroll()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current vertical scroll offset",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["UpdateScrollChildRect"] = {
    ["arguments"] = {
    },
    ["name"] = "UpdateScrollChildRect",
    ["signature"] = "ScrollFrame:UpdateScrollChildRect()",
    ["returns"] = {
    },
    ["desc"] = "Updates the rect information for the scroll child",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["SetScrollChild"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScrollChild",
    ["signature"] = "ScrollFrame:SetScrollChild(frame)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scrollchild for the scroll frame",
  },
  ["SetVerticalScroll"] = {
    ["arguments"] = {
    },
    ["name"] = "SetVerticalScroll",
    ["signature"] = "ScrollFrame:SetVerticalScroll(offset)",
    ["returns"] = {
    },
    ["desc"] = "Sets the vertical scroll for the frame",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["GetScrollChild"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScrollChild",
    ["signature"] = "ScrollFrame:GetScrollChild()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scroll child framem",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
}
ColorSelect = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetColorHSV"] = {
    ["arguments"] = {
      {
        ["type"] = "number",
        ["name"] = "hue",
        ["desc"] = "The hue of the color to set",
      },
      {
        ["type"] = "number",
        ["name"] = "saturation",
        ["desc"] = "The saturation of the color to set",
      },
      {
        ["type"] = "number",
        ["name"] = "value",
        ["desc"] = "The value of the color to set",
      },
    },
    ["name"] = "SetColorHSV",
    ["signature"] = "ColorSelect:SetColorHSV(hue, saturation, value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the ColorSelect widget using hue, saturation and value",
  },
  ["GetColorWheelThumbTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetColorWheelThumbTexture",
    ["signature"] = "ColorSelect:GetColorWheelThumbTexture()",
    ["returns"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The thumb texture for the given ColorSelect widget",
      },
    },
    ["desc"] = "Returns the thumb texture for the ColorSelect widget",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetColorHSV"] = {
    ["arguments"] = {
    },
    ["name"] = "GetColorHSV",
    ["signature"] = "hue, saturation, value = ColorSelect:GetColorHSV()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "hue",
        ["desc"] = "The hue of the currently selected color",
      },
      {
        ["type"] = "number",
        ["name"] = "saturation",
        ["desc"] = "The saturation of the currently selected color",
      },
      {
        ["type"] = "number",
        ["name"] = "value",
        ["desc"] = "The value of the currently selected color",
      },
    },
    ["desc"] = "Returns the hue, saturation and value of the currently selected color",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["SetColorWheelTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "Texture",
        ["optional"] = true,
        ["name"] = "texture",
        ["desc"] = "The texture object you are wanting.",
      },
    },
    ["name"] = "SetColorWheelTexture",
    ["signature"] = "ColorSelect:SetColorWheelTexture(texture)",
    ["returns"] = {
    },
    ["desc"] = "Allows you to set the texture of the color wheel.",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetColorRGB"] = {
    ["arguments"] = {
    },
    ["name"] = "GetColorRGB",
    ["signature"] = "red, green, blue = ColorSelect:GetColorRGB()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "red",
        ["desc"] = "The red component value of the color (0.0 - 1.0)",
      },
      {
        ["type"] = "number",
        ["name"] = "blue",
        ["desc"] = "The blue component value of the color (0.0 - 1.0)",
      },
      {
        ["type"] = "number",
        ["name"] = "green",
        ["desc"] = "The green component value of the color (0.0 - 1.0)",
      },
    },
    ["desc"] = "Returns the component colors of the currently selected color",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["SetColorValueThumbTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "string or Texture",
        ["optional"] = true,
        ["name"] = "texture",
        ["desc"] = "Either a texture objects or a location of a texture file.",
      },
    },
    ["name"] = "SetColorValueThumbTexture",
    ["signature"] = "ColorSelect:SetColorValueThumbTexture(texture or \"texture\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture of the \"Value Thumb\".",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["GetColorWheelTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetColorWheelTexture",
    ["signature"] = "ColorSelect:GetColorWheelTexture()",
    ["returns"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture used for the color wheel for this widget",
      },
    },
    ["desc"] = "Returns the texture used for the color wheel on the given ColorSelect widget",
  },
  ["GetColorValueTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetColorValueTexture",
    ["signature"] = "ColorSelect:GetColorValueTexture()",
    ["returns"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture used to display the color value in the ColorSelect widget",
      },
    },
    ["desc"] = "Returns the texture used to display the color value in the ColorSelect widget",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["GetColorValueThumbTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetColorValueThumbTexture",
    ["signature"] = "ColorSelect:GetColorValueThumbTexture()",
    ["returns"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture used for the color value thumb in the ColorSelect widget",
      },
    },
    ["desc"] = "Returns the texture used for the color value thumb in the ColorSelect widget",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["SetColorValueTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "Texture",
        ["optional"] = true,
        ["name"] = "texture",
        ["desc"] = "The texture object you are wanting.",
      },
    },
    ["name"] = "SetColorValueTexture",
    ["signature"] = "ColorSelect:SetColorValueTexture(texture or nil)",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture of the opacity selector.",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["SetColorWheelThumbTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "string or Texture",
        ["optional"] = true,
        ["name"] = "texture",
        ["desc"] = "Either a texture objects or a location of a texture file.",
      },
    },
    ["name"] = "SetColorWheelThumbTexture",
    ["signature"] = "ColorSelect:SetColorWheelThumbTexture(texture or \"texture\" or nil)",
    ["returns"] = {
    },
    ["desc"] = "Allows you to set the texture of the color wheel thumb.",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["SetColorRGB"] = {
    ["arguments"] = {
      {
        ["type"] = "number",
        ["name"] = "red",
        ["desc"] = "The red component of the color (0.0 - 1.0)",
      },
      {
        ["type"] = "number",
        ["name"] = "blue",
        ["desc"] = "The blue component of the color (0.0 - 1.0)",
      },
      {
        ["type"] = "number",
        ["name"] = "green",
        ["desc"] = "The green component of the color (0.0 - 1.0)",
      },
      {
        ["type"] = "number",
        ["name"] = "alpha",
        ["desc"] = "The alpha transparency level of the color (0.0 - 1.0)",
      },
    },
    ["name"] = "SetColorRGB",
    ["signature"] = "ColorSelect:SetColorRGB(red, blue, green [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the selected color for the given ColorSelect widget with an RGB value",
  },
}
ScrollingMessageFrame = {
  ["SetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyV",
    ["signature"] = "FontInstance:SetJustifyV(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "sets the vertical justification.",
  },
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["ScrollUp"] = {
    ["arguments"] = {
    },
    ["name"] = "ScrollUp",
    ["signature"] = "ScrollingMessageFrame:ScrollUp()",
    ["returns"] = {
    },
    ["desc"] = "Scrolls up in the messgae frame",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetFading"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFading",
    ["signature"] = "ScrollingMessageFrame:GetFading()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not fading is disabled for the frame",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyV",
    ["signature"] = "FontInstance:GetJustifyV()",
    ["returns"] = {
    },
    ["desc"] = "Returns font's vertical justification.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetMaxLines"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxLines",
    ["signature"] = "ScrollingMessageFrame:GetMaxLines()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum number of lines in the message frame",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["GetIndentedWordWrap"] = {
    ["undocumented"] = true,
  },
  ["GetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFont",
    ["signature"] = "fontName, fontHeight, fontFlags = FontInstance:GetFont()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font details of the font instance.",
  },
  ["SetMaxLines"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxLines",
    ["signature"] = "ScrollingMessageFrame:SetMaxLines(maxLines)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum number of lines to be kept in the frame",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["PageUp"] = {
    ["arguments"] = {
    },
    ["name"] = "PageUp",
    ["signature"] = "ScrollingMessageFrame:PageUp()",
    ["returns"] = {
    },
    ["desc"] = "Scrolls up a page in the message frame",
  },
  ["SetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFontObject",
    ["signature"] = "FontInstance:SetFontObject(font or \"font\" or nil)",
    ["returns"] = {
    },
    ["desc"] = "Set a font object to be used as the current font.",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["SetHyperlinksEnabled"] = {
    ["undocumented"] = true,
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["AtTop"] = {
    ["arguments"] = {
    },
    ["name"] = "AtTop",
    ["signature"] = "ScrollingMessageFrame:AtTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the message frame is scrolled all the way to the top",
  },
  ["GetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFontObject",
    ["signature"] = "FontInstance:GetFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font object used by the font if present. See SetFontObject.",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["GetCurrentScroll"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCurrentScroll",
    ["signature"] = "ScrollingMessageFrame:GetCurrentScroll()",
    ["returns"] = {
    },
    ["desc"] = "Gets the current scroll offset for the frame",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["GetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetSpacing",
    ["signature"] = "FontInstance:GetSpacing()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's spacing.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSpacing",
    ["signature"] = "FontInstance:SetSpacing(spacing)",
    ["returns"] = {
    },
    ["desc"] = "Sets the spacing of the font.",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["AddMessage"] = {
    ["arguments"] = {
    },
    ["name"] = "AddMessage",
    ["signature"] = "ScrollingMessageFrame:AddMessage(text [, red, green, blue [, id]])",
    ["returns"] = {
    },
    ["desc"] = "Adds a message to the frame",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["SetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowColor",
    ["signature"] = "FontInstance:SetShadowColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the font's shadow.",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["SetFading"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFading",
    ["signature"] = "ScrollingMessageFrame:SetFading([enabled])",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not text fades after a period of time",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["GetInsertMode"] = {
    ["arguments"] = {
    },
    ["name"] = "GetInsertMode",
    ["signature"] = "ScrollingMessageFrame:GetInsertMode()",
    ["returns"] = {
    },
    ["desc"] = "Returns the insert mode for the scrolling frame",
  },
  ["SetTimeVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTimeVisible",
    ["signature"] = "ScrollingMessageFrame:SetTimeVisible(seconds)",
    ["returns"] = {
    },
    ["desc"] = "Sets the visibile time for messages",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetTimeVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTimeVisible",
    ["signature"] = "ScrollingMessageFrame:GetTimeVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns the amount of time that messages are displayed for",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["UpdateColorByID"] = {
    ["arguments"] = {
    },
    ["name"] = "UpdateColorByID",
    ["signature"] = "ScrollingMessageFrame:UpdateColorByID(id, red, green, blue)",
    ["returns"] = {
    },
    ["desc"] = "Updates the color for a specific message id",
  },
  ["SetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowOffset",
    ["signature"] = "FontInstance:SetShadowOffset(x, y)",
    ["returns"] = {
    },
    ["desc"] = "Sets the distance to offset the shadow of the text.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["SetInsertMode"] = {
    ["arguments"] = {
    },
    ["name"] = "SetInsertMode",
    ["signature"] = "ScrollingMessageFrame:SetInsertMode(\"TOP\" or \"BOTTOM\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the insert mode for the message frame",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["SetScrollOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScrollOffset",
    ["signature"] = "ScrollingMessageFrame:SetScrollOffset()",
    ["returns"] = {
    },
    ["desc"] = "Sets the current scroll offset",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["GetNumLinesDisplayed"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumLinesDisplayed",
    ["signature"] = "ScrollingMessageFrame:GetNumLinesDisplayed()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of lines displayed in the message frame",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["GetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowColor",
    ["signature"] = "red, green, blue, alpha = FontInstance:GetShadowColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the color of the font's text shadow.",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["GetHyperlinksEnabled"] = {
    ["undocumented"] = true,
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["GetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextColor",
    ["signature"] = "r, g, b, a = FontInstance:GetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the default text color for the FontInstance.",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["ScrollToTop"] = {
    ["arguments"] = {
    },
    ["name"] = "ScrollToTop",
    ["signature"] = "ScrollingMessageFrame:ScrollToTop()",
    ["returns"] = {
    },
    ["desc"] = "Scrolls to the top of the message frame",
  },
  ["PageDown"] = {
    ["arguments"] = {
    },
    ["name"] = "PageDown",
    ["signature"] = "ScrollingMessageFrame:PageDown()",
    ["returns"] = {
    },
    ["desc"] = "Scrolls down a page in the message frame",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["GetNumMessages"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumMessages",
    ["signature"] = "ScrollingMessageFrame:GetNumMessages()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of messages in the message frame",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["SetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFont",
    ["signature"] = "FontInstance:SetFont(filename, fontHeight[, flags])",
    ["returns"] = {
    },
    ["desc"] = "Set the font of the font object.",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["Clear"] = {
    ["arguments"] = {
    },
    ["name"] = "Clear",
    ["signature"] = "ScrollingMessageFrame:Clear()",
    ["returns"] = {
    },
    ["desc"] = "Clears the message frame",
  },
  ["GetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyH",
    ["signature"] = "FontInstance:GetJustifyH()",
    ["returns"] = {
    },
    ["desc"] = "Returns the horizontal justification of the text in the FontInstance.",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["SetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyH",
    ["signature"] = "FontInstance:SetJustifyH(\"justify\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the horizontal justification.",
  },
  ["SetFadeDuration"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFadeDuration",
    ["signature"] = "ScrollingMessageFrame:SetFadeDuration(seconds)",
    ["returns"] = {
    },
    ["desc"] = "Sets the fade duration for the frame",
  },
  ["GetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowOffset",
    ["signature"] = "x,y = FontInstance:GetShadowOffset()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font's shadow offset.",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["SetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTextColor",
    ["signature"] = "FontInstance:SetTextColor()",
    ["returns"] = {
    },
    ["desc"] = "Sets the primary (text) color.",
  },
  ["SetIndentedWordWrap"] = {
    ["undocumented"] = true,
  },
  ["ScrollToBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "ScrollToBottom",
    ["signature"] = "ScrollingMessageFrame:ScrollToBottom()",
    ["returns"] = {
    },
    ["desc"] = "Scrolls to the bottom of the message frame",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["AtBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "AtBottom",
    ["signature"] = "ScrollingMessageFrame:AtBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the message frame is scrolled all the way to the bottom",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["ScrollDown"] = {
    ["arguments"] = {
    },
    ["name"] = "ScrollDown",
    ["signature"] = "ScrollingMessageFrame:ScrollDown()",
    ["returns"] = {
    },
    ["desc"] = "Scrolls down in the message frame",
  },
  ["GetCurrentLine"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCurrentLine",
    ["signature"] = "ScrollingMessageFrame:GetCurrentLine()",
    ["returns"] = {
    },
    ["desc"] = "Returns the last line that was added to the frame",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["GetFadeDuration"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFadeDuration",
    ["signature"] = "ScrollingMessageFrame:GetFadeDuration()",
    ["returns"] = {
    },
    ["desc"] = "Returns the fade duration for the text",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
}
Minimap = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetPlayerModel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPlayerModel",
    ["signature"] = "Minimap:SetPlayerModel(\"file\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the model of the player on the minimap.",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["PingLocation"] = {
    ["arguments"] = {
    },
    ["name"] = "PingLocation",
    ["signature"] = "Minimap:PingLocation(x, y)",
    ["returns"] = {
    },
    ["desc"] = "Pings the minimap at the given coordinate (relative to the center).",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["SetArrowModel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetArrowModel",
    ["signature"] = "Minimap:SetArrowModel(\"file\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the model of the minimap arrow.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["GetZoom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetZoom",
    ["signature"] = "Minimap:GetZoom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current zoom level for the Minimap.",
  },
  ["GetZoomLevels"] = {
    ["arguments"] = {
    },
    ["name"] = "GetZoomLevels",
    ["signature"] = "Minimap:GetZoomLevels()",
    ["returns"] = {
    },
    ["desc"] = "Returns the highest zoom level you are allowed to use for Minimap:SetZoom.",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["SetZoom"] = {
    ["arguments"] = {
    },
    ["name"] = "SetZoom",
    ["signature"] = "Minimap:SetZoom(zoom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimap zoom.",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["SetMaskTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaskTexture",
    ["signature"] = "Minimap:SetMaskTexture(\"file\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture to mask the minimap texture with.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["SetBlipTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBlipTexture",
    ["signature"] = "Minimap:SetBlipTexture(\"file\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture of the minimap blips.",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetPingPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPingPosition",
    ["signature"] = "x, y = Minimap:GetPingPosition()",
    ["returns"] = {
    },
    ["desc"] = "Returns the coordinates of the last ping on the minimap (relative to the center).",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["SetIconTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "SetIconTexture",
    ["signature"] = "Minimap:SetIconTexture(path)",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture for the minimap icons.",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
}
SimpleHTML = {
  ["SetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyV",
    ["signature"] = "SimpleHTML:SetJustifyV([\"element\"], \"justify\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the vertical alignment of the font",
  },
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["SetIndentedWordWrap"] = {
    ["undocumented"] = true,
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetJustifyV"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyV",
    ["signature"] = "SimpleHTML:GetJustifyV([\"element\"])",
    ["returns"] = {
    },
    ["desc"] = "Returns the vertical alignment of the font",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["SetText"] = {
    ["arguments"] = {
    },
    ["name"] = "SetText",
    ["signature"] = "SimpleHTML:SetText(\"text\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the text of the SimpleHTML frame",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowOffset",
    ["signature"] = "SimpleHTML:SetShadowOffset([element], x, y)",
    ["returns"] = {
    },
    ["desc"] = "Sets the offset for the font's shadow",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["GetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFont",
    ["signature"] = "font, height, ... = SimpleHTML:GetFont([\"element\"])",
    ["returns"] = {
    },
    ["desc"] = "Return the font information for the frame",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetHyperlinkFormat"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHyperlinkFormat",
    ["signature"] = "SimpleHTML:GetHyperlinkFormat()",
    ["returns"] = {
    },
    ["desc"] = "Returns the hyperlink format for the framer",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["SetFont"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFont",
    ["signature"] = "SimpleHTML:SetFont([\"element\"], \"font\", fontHeight [, flags])",
    ["returns"] = {
    },
    ["desc"] = "Sets the font file, height and flags to be used",
  },
  ["SetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFontObject",
    ["signature"] = "SimpleHTML:SetFontObject([\"element\"], font or \"font\" or nil)",
    ["returns"] = {
    },
    ["desc"] = "Sets the font object to be used",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetHyperlinksEnabled"] = {
    ["undocumented"] = true,
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["SetHyperlinksEnabled"] = {
    ["undocumented"] = true,
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["GetFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFontObject",
    ["signature"] = "SimpleHTML:GetFontObject([\"element\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the font object for the frame",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["GetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextColor",
    ["signature"] = "red, green, blue, alpha = SimpleHTML:GetTextColor([\"element\"])",
    ["returns"] = {
    },
    ["desc"] = "Returns the color of the font",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetSpacing",
    ["signature"] = "SimpleHTML:GetSpacing([\"element\"])",
    ["returns"] = {
    },
    ["desc"] = "Returns the line spacing of the font",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["SetSpacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSpacing",
    ["signature"] = "SimpleHTML:SetSpacing([\"element\"], spacing)",
    ["returns"] = {
    },
    ["desc"] = "Sets the spacing between lines in the display",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowColor",
    ["signature"] = "red, green, blue, alpha = SimpleHTML:GetShadowColor([element])",
    ["returns"] = {
    },
    ["desc"] = "Returns the shadow color for the font.",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["GetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "GetJustifyH",
    ["signature"] = "SimpleHTML:GetJustifyH([\"element\"])",
    ["returns"] = {
    },
    ["desc"] = "Returns the horizontal alignment of the frame",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["SetJustifyH"] = {
    ["arguments"] = {
    },
    ["name"] = "SetJustifyH",
    ["signature"] = "SimpleHTML:SetJustifyH([\"element\"], \"justify\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the horizontal alignment for the font",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["GetShadowOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "GetShadowOffset",
    ["signature"] = "x, y = SimpleHTML:GetShadowOffset([\"element\"])",
    ["returns"] = {
    },
    ["desc"] = "Returns the shadow offset for the font",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["SetTextColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetTextColor",
    ["signature"] = "SimpleHTML:SetTextColor([\"element\"], red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the text color (optionally for a given SimpleHTML element such as <p>, <h1>, etc.)",
  },
  ["SetShadowColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetShadowColor",
    ["signature"] = "SimpleHTML:SetShadowColor([element,] red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the font's shadow",
  },
  ["GetIndentedWordWrap"] = {
    ["undocumented"] = true,
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["SetHyperlinkFormat"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHyperlinkFormat",
    ["signature"] = "SimpleHTML:SetHyperlinkFormat(\"format\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the format to use for hyperlinks in the framr",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
}
Button = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["RegisterForClicks"] = {
    ["arguments"] = {
      {
        ["type"] = "string",
        ["name"] = "...",
        ["desc"] = "A list of clicks that the button should register for.  A click is a mouse button name (\"LeftButton\", \"RightButton\", \"MiddleButton\", \"Button4\", \"Button5\", \"Any\") along with a direction (\"Up\" or \"Down\").  The \"Any\" button can be used to register for all buttons at once",
      },
    },
    ["name"] = "RegisterForClicks",
    ["signature"] = "Button:RegisterForClicks(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers a button to receive mouse clicks",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["IsEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEnabled",
    ["signature"] = "Button:IsEnabled()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "isEnabled",
        ["desc"] = "1 if the button is enabled, otherwise 0",
      },
    },
    ["desc"] = "Returns if the button is enabled",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["GetNormalTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNormalTexture",
    ["signature"] = "Button:GetNormalTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Texture object that is displayed when the button is in its normal state.",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["SetNormalTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture to set as the button's \"Normal\" texture.",
      },
    },
    ["name"] = "SetNormalTexture",
    ["signature"] = "Button:SetNormalTexture(texture)",
    ["returns"] = {
    },
    ["desc"] = "Sets a buttons normal texture",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["GetTextHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextHeight",
    ["signature"] = "Button:GetTextHeight()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "height",
        ["desc"] = "The height of the button's text, in pixels",
      },
    },
    ["desc"] = "Returns the height of the button's text",
  },
  ["SetPushedTextOffset"] = {
    ["arguments"] = {
      {
        ["type"] = "number",
        ["name"] = "x",
        ["desc"] = "The x axis offset for the pushed text",
      },
      {
        ["type"] = "number",
        ["name"] = "y",
        ["desc"] = "The y axis offset for the pushed text",
      },
    },
    ["name"] = "SetPushedTextOffset",
    ["signature"] = "Button:SetPushedTextOffset(x, y)",
    ["returns"] = {
    },
    ["desc"] = "Sets the offset for the button's label when the button is pushed",
  },
  ["Click"] = {
    ["arguments"] = {
    },
    ["name"] = "Click",
    ["signature"] = "Button:Click(mouseButton, down)",
    ["returns"] = {
    },
    ["desc"] = "Simulates a click on the given button.",
  },
  ["UnlockHighlight"] = {
    ["arguments"] = {
    },
    ["name"] = "UnlockHighlight",
    ["signature"] = "Button:UnlockHighlight()",
    ["returns"] = {
    },
    ["desc"] = "Unlocks the button's highlight state, so it operates normally",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetHighlightFontObject"] = {
    ["arguments"] = {
      {
        ["type"] = "Font",
        ["name"] = "font",
        ["desc"] = "The font object to be used for the button's highlight text",
      },
    },
    ["name"] = "SetHighlightFontObject",
    ["signature"] = "Button:SetHighlightFontObject(font)",
    ["returns"] = {
    },
    ["desc"] = "Sets the font object to be used for the button's highlight text",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["Disable"] = {
    ["arguments"] = {
    },
    ["name"] = "Disable",
    ["signature"] = "Button:Disable()",
    ["returns"] = {
    },
    ["desc"] = "Disabled the button so it cannot be clicked",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["GetNormalFontObject"] = {
    ["undocumented"] = true,
  },
  ["SetFontString"] = {
    ["arguments"] = {
      {
        ["type"] = "FontString",
        ["name"] = "fontstring",
        ["desc"] = "The fontstring to use for the button text",
      },
    },
    ["name"] = "SetFontString",
    ["signature"] = "Button:SetFontString(fontstring)",
    ["returns"] = {
    },
    ["desc"] = "Sets the button's label FontString",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["GetDisabledFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetDisabledFontObject",
    ["signature"] = "Button:GetDisabledFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Font object used when the button is in the DISABLED state",
  },
  ["GetText"] = {
    ["arguments"] = {
    },
    ["name"] = "GetText",
    ["signature"] = "text = Button:GetText()",
    ["returns"] = {
      {
        ["type"] = "string",
        ["name"] = "text",
        ["desc"] = "The text of the button's label",
      },
    },
    ["desc"] = "Returns the text of the button's label",
  },
  ["SetDisabledFontObject"] = {
    ["arguments"] = {
      {
        ["type"] = "Font",
        ["name"] = "font",
        ["desc"] = "The font object to be used when the button is disabled",
      },
    },
    ["name"] = "SetDisabledFontObject",
    ["signature"] = "Button:SetDisabledFontObject(font)",
    ["returns"] = {
    },
    ["desc"] = "Sets the font object to be used when the button is disabled",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetNormalFontObject"] = {
    ["undocumented"] = true,
  },
  ["SetHighlightTexture"] = {
    ["arguments"] = {
      {
        ["group"] = "choice",
        ["choices"] = {
          {
            ["type"] = "Texture",
            ["name"] = "texture",
            ["desc"] = "A texture object to be used when the button is highlighted",
          },
          {
            ["type"] = "string",
            ["name"] = "texture",
            ["desc"] = "The path to a texture file to be used when the button is highlighted",
          },
        },
      },
      {
        ["type"] = "string",
        ["name"] = "blendmode",
        ["values"] = {
          ["DISABLE"] = "No alpha blending, the texture should be drawn opaque",
          ["MOD"] = "Use modulating blending when drawing the texture",
          ["BLEND"] = "Draw the image on top of the current texture, using the alpha channel if present",
          ["ADD"] = "Use additive blending when drawing the texture",
          ["ALPHAKEY"] = "Draw the image on top of the current texture, using a 1-bit alpha channe",
        },
        ["optional"] = true,
        ["desc"] = "The blend mode to use for the highlight texture",
      },
    },
    ["name"] = "SetHighlightTexture",
    ["signature"] = "Button:SetHighlightTexture(texture or \"texture\" [, \"blendmode\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the highlight texture and blend mode for the button",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetHighlightFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHighlightFontObject",
    ["signature"] = "Button:GetHighlightFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font object used for the button's highlight text",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["GetPushedTextOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPushedTextOffset",
    ["signature"] = "x, y = Button:GetPushedTextOffset()",
    ["returns"] = {
    },
    ["desc"] = "Returns the text offset for when the button is in the PUSHED state.",
  },
  ["GetPushedTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPushedTexture",
    ["signature"] = "Button:GetPushedTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the texture that is displayed when the button is in the PUSHED state",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["SetPushedTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture to be used when the button is in the PUSHED state",
      },
    },
    ["name"] = "SetPushedTexture",
    ["signature"] = "Button:SetPushedTexture(texture)",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture to be used when the button is in the PUSHED state",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["SetFormattedText"] = {
    ["arguments"] = {
      {
        ["type"] = "string",
        ["name"] = "fmt",
        ["desc"] = "A format string to be passed to string.format()",
      },
      {
        ["type"] = "values",
        ["name"] = "...",
        ["desc"] = "A list of arguments to the string.format() function corresponding to the specified format string",
      },
    },
    ["name"] = "SetFormattedText",
    ["signature"] = "Button:SetFormattedText(fmt, ...)",
    ["returns"] = {
    },
    ["desc"] = "Sets the button's label, using a format string and arguments",
  },
  ["Enable"] = {
    ["arguments"] = {
    },
    ["name"] = "Enable",
    ["signature"] = "Button:Enable()",
    ["returns"] = {
    },
    ["desc"] = "Enables the button for clicks.",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["GetTextWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextWidth",
    ["signature"] = "Button:GetTextWidth()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "width",
        ["desc"] = "The width of the button's label, in pixels",
      },
    },
    ["desc"] = "Returns the width of the button's label",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["GetHighlightTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHighlightTexture",
    ["signature"] = "Button:GetHighlightTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Texture object that is displayed when the button is highlighted.",
  },
  ["LockHighlight"] = {
    ["arguments"] = {
    },
    ["name"] = "LockHighlight",
    ["signature"] = "Button:LockHighlight()",
    ["returns"] = {
    },
    ["desc"] = "Locks the button's highlight state, so it is always drawn as highlighted",
  },
  ["GetDisabledTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetDisabledTexture",
    ["signature"] = "Button:GetDisabledTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the texture object that is displayed when the button is in the DISABLED state",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetDisabledTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture to use when the button is disabled",
      },
    },
    ["name"] = "SetDisabledTexture",
    ["signature"] = "Button:SetDisabledTexture(texture)",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture to be used when the button is disabled",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["SetText"] = {
    ["arguments"] = {
      {
        ["type"] = "string",
        ["name"] = "text",
        ["desc"] = "The text to be displayed on the button's label",
      },
    },
    ["name"] = "SetText",
    ["signature"] = "Button:SetText(\"text\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the text to be displayed on the button's label",
  },
  ["GetButtonState"] = {
    ["arguments"] = {
    },
    ["name"] = "GetButtonState",
    ["signature"] = "Button:GetButtonState()",
    ["returns"] = {
    },
    ["desc"] = "Returns the buton's current state: \"NORMAL\", \"PUSHED\", or \"DISABLED\".",
  },
  ["SetButtonState"] = {
    ["arguments"] = {
      {
        ["name"] = "state",
        ["type"] = "string",
        ["values"] = {
          ["PUSHED"] = "The button is pushed",
          ["NORMAL"] = "The button is normal",
          ["DISABLED"] = "The button is disabled",
        },
        ["desc"] = "The state of the button",
      },
      {
        ["type"] = "boolean",
        ["name"] = "lock",
        ["desc"] = "Locks the button in the given state.  If the state is \"NORMAL\" the buton cannot be clicked but remains in the \"NORMAL\" state, and similarly for \"PUSHED\" and \"DISABLED\".",
      },
    },
    ["name"] = "SetButtonState",
    ["signature"] = "Button:SetButtonState(\"state\", lock)",
    ["returns"] = {
    },
    ["desc"] = "Sets a button's state, optionally locking it into that state",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["GetFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFontString",
    ["signature"] = "Button:GetFontString()",
    ["returns"] = {
    },
    ["desc"] = "Returns the FontString object that is used for the button's label.",
  },
}
StatusBar = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["GetOrientation"] = {
    ["arguments"] = {
    },
    ["name"] = "GetOrientation",
    ["signature"] = "StatusBar:GetOrientation()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current orientation of the status bar",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetMinMaxValues"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinMaxValues",
    ["signature"] = "min, max = StatusBar:GetMinMaxValues()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum and maximum values of the status bar",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["SetOrientation"] = {
    ["arguments"] = {
    },
    ["name"] = "SetOrientation",
    ["signature"] = "StatusBar:SetOrientation(\"orientation\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the orientation of the status bar",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["GetStatusBarColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetStatusBarColor",
    ["signature"] = "red, green, blue, alpha = StatusBar:GetStatusBarColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current color of the status bar texture",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetStatusBarColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetStatusBarColor",
    ["signature"] = "StatusBar:SetStatusBarColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the status bar texture",
  },
  ["SetMinMaxValues"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinMaxValues",
    ["signature"] = "StatusBar:SetMinMaxValues(min, max)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum and maximum values for the status bar",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["SetStatusBarTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "SetStatusBarTexture",
    ["signature"] = "StatusBar:SetStatusBarTexture(texture or \"texture\" [, \"layer\"])",
    ["returns"] = {
    },
    ["desc"] = "Sets the status bar texture",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetValue"] = {
    ["arguments"] = {
    },
    ["name"] = "GetValue",
    ["signature"] = "StatusBar:GetValue()",
    ["returns"] = {
    },
    ["desc"] = "Gets the current value of the status bar",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetStatusBarTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetStatusBarTexture",
    ["signature"] = "StatusBar:GetStatusBarTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current status bar texture",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["SetValue"] = {
    ["arguments"] = {
    },
    ["name"] = "SetValue",
    ["signature"] = "StatusBar:SetValue(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the current value of the status bar",
  },
}
MovieFrame = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["EnableSubtitles"] = {
    ["undocumented"] = true,
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["StopMovie"] = {
    ["undocumented"] = true,
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["StartMovie"] = {
    ["undocumented"] = true,
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
}
PlayerModel = {
  ["RefreshUnit"] = {
    ["arguments"] = {
    },
    ["name"] = "RefreshUnit",
    ["signature"] = "PlayerModel:RefreshUnit()",
    ["returns"] = {
    },
    ["desc"] = "Refreshes the model given its current unit.",
  },
  ["GetModel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetModel",
    ["signature"] = "Model:GetModel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the file name currently used by the model.",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetCamera"] = {
    ["arguments"] = {
    },
    ["name"] = "SetCamera",
    ["signature"] = "Model:SetCamera(index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the pre-defined camera view for the model.",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["ClearModel"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearModel",
    ["signature"] = "Model:ClearModel()",
    ["returns"] = {
    },
    ["desc"] = "Removes the current mesh from the Model object.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetFogFar"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogFar",
    ["signature"] = "Model:SetFogFar(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the far clipping distance for the model's fog.",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["SetModelScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetModelScale",
    ["signature"] = "Model:SetModelScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the mesh displayed by the Model.",
  },
  ["GetModelScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetModelScale",
    ["signature"] = "Model:GetModelScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the mesh displayed by the Model",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetFogFar"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogFar",
    ["signature"] = "Model:GetFogFar()",
    ["returns"] = {
    },
    ["desc"] = "Returns the far clipping distance for the model's fog.",
  },
  ["SetModel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetModel",
    ["signature"] = "Model:SetModel(filename)",
    ["returns"] = {
    },
    ["desc"] = "Sets the model to the specified file.",
  },
  ["SetGlow"] = {
    ["undocumented"] = true,
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["SetRotation"] = {
    ["arguments"] = {
    },
    ["name"] = "SetRotation",
    ["signature"] = "PlayerModel:SetRotation(angle)",
    ["returns"] = {
    },
    ["desc"] = "Sets the rotation angle (in radians) of the mesh displayed in the PlayerModel.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["SetCreature"] = {
    ["undocumented"] = true,
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["SetSequence"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSequence",
    ["signature"] = "Model:SetSequence(sequence)",
    ["returns"] = {
    },
    ["desc"] = "Sets the model to use the specified animation sequence.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["SetUnit"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUnit",
    ["signature"] = "PlayerModel:SetUnit(unitId)",
    ["returns"] = {
    },
    ["desc"] = "Sets the PlayerModel to display the given unit.",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetLight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetLight",
    ["signature"] = "Model:SetLight(enabled[, omni, dirX, dirY, dirZ, ambIntensity[, ambR, ambG, ambB], dirIntensity[, dirR, dirG, dirB]])",
    ["returns"] = {
    },
    ["desc"] = "Sets the origin of the lightsource for rendering of the model",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["GetLight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLight",
    ["signature"] = "... = Model:GetLight()",
    ["returns"] = {
    },
    ["desc"] = "Returns information about the light source used when rendering the model",
  },
  ["ReplaceIconTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "ReplaceIconTexture",
    ["signature"] = "Model:ReplaceIconTexture(path)",
    ["returns"] = {
    },
    ["desc"] = "Sets the icon texture path used by the model.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["SetFogNear"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogNear",
    ["signature"] = "Model:SetFogNear(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the near clipping distance for the model's fog.",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["AdvanceTime"] = {
    ["arguments"] = {
    },
    ["name"] = "AdvanceTime",
    ["signature"] = "Model:AdvanceTime()",
    ["returns"] = {
    },
    ["desc"] = "Advances to the next animation frame for the model.",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["GetFogNear"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogNear",
    ["signature"] = "Model:GetFogNear()",
    ["returns"] = {
    },
    ["desc"] = "Returns the near clipping distance for the model's fog.",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["GetFacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFacing",
    ["signature"] = "Model:GetFacing()",
    ["returns"] = {
    },
    ["desc"] = "Gets the current rotation angle of the model in radians.",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["SetPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPosition",
    ["signature"] = "Model:SetPosition(x, y, z)",
    ["returns"] = {
    },
    ["desc"] = "Sets the position of the mesh displayed by the Model.",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["SetSequenceTime"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSequenceTime",
    ["signature"] = "Model:SetSequenceTime(sequence, time)",
    ["returns"] = {
    },
    ["desc"] = "Sets the animation sequence and time index for the Model.",
  },
  ["SetFogColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogColor",
    ["signature"] = "Model:SetFogColor(r, g, b[, a])",
    ["returns"] = {
    },
    ["desc"] = "Sets the fog color and enables fog display for the model.",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetFogColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogColor",
    ["signature"] = "r, g, b, a = Model:GetFogColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current fog color for the Model.",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["GetPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPosition",
    ["signature"] = "x, y, z = Model:GetPosition()",
    ["returns"] = {
    },
    ["desc"] = "Returns the position of the mesh displayed by the Model object.",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["SetFacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFacing",
    ["signature"] = "Model:SetFacing(facing)",
    ["returns"] = {
    },
    ["desc"] = "Gets the current rotation angle of the model in radians.",
  },
  ["ClearFog"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearFog",
    ["signature"] = "Model:ClearFog()",
    ["returns"] = {
    },
    ["desc"] = "Disables fog display for the model.",
  },
}
CheckButton = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["RegisterForClicks"] = {
    ["arguments"] = {
      {
        ["type"] = "string",
        ["name"] = "...",
        ["desc"] = "A list of clicks that the button should register for.  A click is a mouse button name (\"LeftButton\", \"RightButton\", \"MiddleButton\", \"Button4\", \"Button5\", \"Any\") along with a direction (\"Up\" or \"Down\").  The \"Any\" button can be used to register for all buttons at once",
      },
    },
    ["name"] = "RegisterForClicks",
    ["signature"] = "Button:RegisterForClicks(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers a button to receive mouse clicks",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["IsEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEnabled",
    ["signature"] = "Button:IsEnabled()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "isEnabled",
        ["desc"] = "1 if the button is enabled, otherwise 0",
      },
    },
    ["desc"] = "Returns if the button is enabled",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["GetNormalTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNormalTexture",
    ["signature"] = "Button:GetNormalTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Texture object that is displayed when the button is in its normal state.",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["SetChecked"] = {
    ["arguments"] = {
      {
        ["type"] = "boolean",
        ["name"] = "checked",
        ["desc"] = "Any Lua value that evaluates to true will check the CheckBox.  Any false values will uncheck the CheckBox",
      },
    },
    ["name"] = "SetChecked",
    ["signature"] = "CheckButton:SetChecked(checked)",
    ["returns"] = {
    },
    ["desc"] = "Sets the checked state of a CheckButton",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetChecked"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChecked",
    ["signature"] = "CheckButton:GetChecked()",
    ["returns"] = {
      {
        ["type"] = "1nil",
        ["name"] = "isChecked",
        ["desc"] = "1 if the checkbutton is checked, otherwise nil",
      },
    },
    ["desc"] = "Returns if a checkbutton is checked",
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["SetNormalTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture to set as the button's \"Normal\" texture.",
      },
    },
    ["name"] = "SetNormalTexture",
    ["signature"] = "Button:SetNormalTexture(texture)",
    ["returns"] = {
    },
    ["desc"] = "Sets a buttons normal texture",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetDisabledCheckedTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetDisabledCheckedTexture",
    ["signature"] = "CheckButton:GetDisabledCheckedTexture()",
    ["returns"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture displayed when the CheckButton is checked, but disabled",
      },
    },
    ["desc"] = "Returns the DisabledChecked texture for the CheckButton",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["SetDisabledCheckedTexture"] = {
    ["arguments"] = {
      {
        ["group"] = "choice",
        ["choices"] = {
          {
            ["type"] = "string",
            ["name"] = "texture",
            ["desc"] = "The path to a texture",
          },
          {
            ["type"] = "Texture",
            ["name"] = "textureObject",
            ["desc"] = "A texture object",
          },
        },
      },
    },
    ["name"] = "SetDisabledCheckedTexture",
    ["signature"] = "CheckButton:SetDisabledCheckedTexture(texture or \"texture\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture to be displayed when the CheckButton is disabled and checked",
  },
  ["GetTextHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextHeight",
    ["signature"] = "Button:GetTextHeight()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "height",
        ["desc"] = "The height of the button's text, in pixels",
      },
    },
    ["desc"] = "Returns the height of the button's text",
  },
  ["SetPushedTextOffset"] = {
    ["arguments"] = {
      {
        ["type"] = "number",
        ["name"] = "x",
        ["desc"] = "The x axis offset for the pushed text",
      },
      {
        ["type"] = "number",
        ["name"] = "y",
        ["desc"] = "The y axis offset for the pushed text",
      },
    },
    ["name"] = "SetPushedTextOffset",
    ["signature"] = "Button:SetPushedTextOffset(x, y)",
    ["returns"] = {
    },
    ["desc"] = "Sets the offset for the button's label when the button is pushed",
  },
  ["Click"] = {
    ["arguments"] = {
    },
    ["name"] = "Click",
    ["signature"] = "Button:Click(mouseButton, down)",
    ["returns"] = {
    },
    ["desc"] = "Simulates a click on the given button.",
  },
  ["UnlockHighlight"] = {
    ["arguments"] = {
    },
    ["name"] = "UnlockHighlight",
    ["signature"] = "Button:UnlockHighlight()",
    ["returns"] = {
    },
    ["desc"] = "Unlocks the button's highlight state, so it operates normally",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["SetHighlightFontObject"] = {
    ["arguments"] = {
      {
        ["type"] = "Font",
        ["name"] = "font",
        ["desc"] = "The font object to be used for the button's highlight text",
      },
    },
    ["name"] = "SetHighlightFontObject",
    ["signature"] = "Button:SetHighlightFontObject(font)",
    ["returns"] = {
    },
    ["desc"] = "Sets the font object to be used for the button's highlight text",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["Disable"] = {
    ["arguments"] = {
    },
    ["name"] = "Disable",
    ["signature"] = "Button:Disable()",
    ["returns"] = {
    },
    ["desc"] = "Disabled the button so it cannot be clicked",
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["SetCheckedTexture"] = {
    ["arguments"] = {
      {
        ["group"] = "choice",
        ["choices"] = {
          {
            ["type"] = "string",
            ["name"] = "texture",
            ["desc"] = "The path to a texture",
          },
          {
            ["type"] = "Texture",
            ["name"] = "textureObject",
            ["desc"] = "A texture object",
          },
        },
      },
    },
    ["name"] = "SetCheckedTexture",
    ["signature"] = "CheckButton:SetCheckedTexture(texture or \"texture\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture to be displayed when the CheckButton is checked",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["GetNormalFontObject"] = {
    ["undocumented"] = true,
  },
  ["SetFontString"] = {
    ["arguments"] = {
      {
        ["type"] = "FontString",
        ["name"] = "fontstring",
        ["desc"] = "The fontstring to use for the button text",
      },
    },
    ["name"] = "SetFontString",
    ["signature"] = "Button:SetFontString(fontstring)",
    ["returns"] = {
    },
    ["desc"] = "Sets the button's label FontString",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["GetDisabledFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetDisabledFontObject",
    ["signature"] = "Button:GetDisabledFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Font object used when the button is in the DISABLED state",
  },
  ["GetText"] = {
    ["arguments"] = {
    },
    ["name"] = "GetText",
    ["signature"] = "text = Button:GetText()",
    ["returns"] = {
      {
        ["type"] = "string",
        ["name"] = "text",
        ["desc"] = "The text of the button's label",
      },
    },
    ["desc"] = "Returns the text of the button's label",
  },
  ["SetDisabledFontObject"] = {
    ["arguments"] = {
      {
        ["type"] = "Font",
        ["name"] = "font",
        ["desc"] = "The font object to be used when the button is disabled",
      },
    },
    ["name"] = "SetDisabledFontObject",
    ["signature"] = "Button:SetDisabledFontObject(font)",
    ["returns"] = {
    },
    ["desc"] = "Sets the font object to be used when the button is disabled",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["SetNormalFontObject"] = {
    ["undocumented"] = true,
  },
  ["SetHighlightTexture"] = {
    ["arguments"] = {
      {
        ["group"] = "choice",
        ["choices"] = {
          {
            ["type"] = "Texture",
            ["name"] = "texture",
            ["desc"] = "A texture object to be used when the button is highlighted",
          },
          {
            ["type"] = "string",
            ["name"] = "texture",
            ["desc"] = "The path to a texture file to be used when the button is highlighted",
          },
        },
      },
      {
        ["type"] = "string",
        ["name"] = "blendmode",
        ["values"] = {
          ["DISABLE"] = "No alpha blending, the texture should be drawn opaque",
          ["MOD"] = "Use modulating blending when drawing the texture",
          ["BLEND"] = "Draw the image on top of the current texture, using the alpha channel if present",
          ["ADD"] = "Use additive blending when drawing the texture",
          ["ALPHAKEY"] = "Draw the image on top of the current texture, using a 1-bit alpha channe",
        },
        ["optional"] = true,
        ["desc"] = "The blend mode to use for the highlight texture",
      },
    },
    ["name"] = "SetHighlightTexture",
    ["signature"] = "Button:SetHighlightTexture(texture or \"texture\" [, \"blendmode\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the highlight texture and blend mode for the button",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["GetHighlightFontObject"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHighlightFontObject",
    ["signature"] = "Button:GetHighlightFontObject()",
    ["returns"] = {
    },
    ["desc"] = "Returns the font object used for the button's highlight text",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["GetPushedTextOffset"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPushedTextOffset",
    ["signature"] = "x, y = Button:GetPushedTextOffset()",
    ["returns"] = {
    },
    ["desc"] = "Returns the text offset for when the button is in the PUSHED state.",
  },
  ["GetPushedTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPushedTexture",
    ["signature"] = "Button:GetPushedTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the texture that is displayed when the button is in the PUSHED state",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["SetPushedTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture to be used when the button is in the PUSHED state",
      },
    },
    ["name"] = "SetPushedTexture",
    ["signature"] = "Button:SetPushedTexture(texture)",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture to be used when the button is in the PUSHED state",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["SetFormattedText"] = {
    ["arguments"] = {
      {
        ["type"] = "string",
        ["name"] = "fmt",
        ["desc"] = "A format string to be passed to string.format()",
      },
      {
        ["type"] = "values",
        ["name"] = "...",
        ["desc"] = "A list of arguments to the string.format() function corresponding to the specified format string",
      },
    },
    ["name"] = "SetFormattedText",
    ["signature"] = "Button:SetFormattedText(fmt, ...)",
    ["returns"] = {
    },
    ["desc"] = "Sets the button's label, using a format string and arguments",
  },
  ["Enable"] = {
    ["arguments"] = {
    },
    ["name"] = "Enable",
    ["signature"] = "Button:Enable()",
    ["returns"] = {
    },
    ["desc"] = "Enables the button for clicks.",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["GetTextWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTextWidth",
    ["signature"] = "Button:GetTextWidth()",
    ["returns"] = {
      {
        ["type"] = "number",
        ["name"] = "width",
        ["desc"] = "The width of the button's label, in pixels",
      },
    },
    ["desc"] = "Returns the width of the button's label",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["LockHighlight"] = {
    ["arguments"] = {
    },
    ["name"] = "LockHighlight",
    ["signature"] = "Button:LockHighlight()",
    ["returns"] = {
    },
    ["desc"] = "Locks the button's highlight state, so it is always drawn as highlighted",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["SetText"] = {
    ["arguments"] = {
      {
        ["type"] = "string",
        ["name"] = "text",
        ["desc"] = "The text to be displayed on the button's label",
      },
    },
    ["name"] = "SetText",
    ["signature"] = "Button:SetText(\"text\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the text to be displayed on the button's label",
  },
  ["GetHighlightTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHighlightTexture",
    ["signature"] = "Button:GetHighlightTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Texture object that is displayed when the button is highlighted.",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["GetDisabledTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetDisabledTexture",
    ["signature"] = "Button:GetDisabledTexture()",
    ["returns"] = {
    },
    ["desc"] = "Returns the texture object that is displayed when the button is in the DISABLED state",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["SetDisabledTexture"] = {
    ["arguments"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture to use when the button is disabled",
      },
    },
    ["name"] = "SetDisabledTexture",
    ["signature"] = "Button:SetDisabledTexture(texture)",
    ["returns"] = {
    },
    ["desc"] = "Sets the texture to be used when the button is disabled",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["GetButtonState"] = {
    ["arguments"] = {
    },
    ["name"] = "GetButtonState",
    ["signature"] = "Button:GetButtonState()",
    ["returns"] = {
    },
    ["desc"] = "Returns the buton's current state: \"NORMAL\", \"PUSHED\", or \"DISABLED\".",
  },
  ["SetButtonState"] = {
    ["arguments"] = {
      {
        ["name"] = "state",
        ["type"] = "string",
        ["values"] = {
          ["PUSHED"] = "The button is pushed",
          ["NORMAL"] = "The button is normal",
          ["DISABLED"] = "The button is disabled",
        },
        ["desc"] = "The state of the button",
      },
      {
        ["type"] = "boolean",
        ["name"] = "lock",
        ["desc"] = "Locks the button in the given state.  If the state is \"NORMAL\" the buton cannot be clicked but remains in the \"NORMAL\" state, and similarly for \"PUSHED\" and \"DISABLED\".",
      },
    },
    ["name"] = "SetButtonState",
    ["signature"] = "Button:SetButtonState(\"state\", lock)",
    ["returns"] = {
    },
    ["desc"] = "Sets a button's state, optionally locking it into that state",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["GetCheckedTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCheckedTexture",
    ["signature"] = "CheckButton:GetCheckedTexture()",
    ["returns"] = {
      {
        ["type"] = "Texture",
        ["name"] = "texture",
        ["desc"] = "The texture displayed when the CheckButton is checked",
      },
    },
    ["desc"] = "Returns the texture that is displayed when the CheckButton is checked",
  },
  ["GetFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFontString",
    ["signature"] = "Button:GetFontString()",
    ["returns"] = {
    },
    ["desc"] = "Returns the FontString object that is used for the button's label.",
  },
}
TabardModel = {
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["GetModel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetModel",
    ["signature"] = "Model:GetModel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the file name currently used by the model.",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetCamera"] = {
    ["arguments"] = {
    },
    ["name"] = "SetCamera",
    ["signature"] = "Model:SetCamera(index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the pre-defined camera view for the model.",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetFogFar"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogFar",
    ["signature"] = "Model:SetFogFar(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the far clipping distance for the model's fog.",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["GetLowerBackgroundFileName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLowerBackgroundFileName",
    ["signature"] = "TabardModel:GetLowerBackgroundFileName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the path to the lower background texture file",
  },
  ["SetModelScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetModelScale",
    ["signature"] = "Model:SetModelScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the mesh displayed by the Model.",
  },
  ["GetModelScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetModelScale",
    ["signature"] = "Model:GetModelScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the mesh displayed by the Model",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["SetSequenceTime"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSequenceTime",
    ["signature"] = "Model:SetSequenceTime(sequence, time)",
    ["returns"] = {
    },
    ["desc"] = "Sets the animation sequence and time index for the Model.",
  },
  ["CycleVariation"] = {
    ["arguments"] = {
    },
    ["name"] = "CycleVariation",
    ["signature"] = "TabardModel:CycleVariation(variationIndex, delta)",
    ["returns"] = {
    },
    ["desc"] = "Cycles through a tabard model's variations by delta.",
  },
  ["GetFogFar"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogFar",
    ["signature"] = "Model:GetFogFar()",
    ["returns"] = {
    },
    ["desc"] = "Returns the far clipping distance for the model's fog.",
  },
  ["SetModel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetModel",
    ["signature"] = "Model:SetModel(filename)",
    ["returns"] = {
    },
    ["desc"] = "Sets the model to the specified file.",
  },
  ["SetGlow"] = {
    ["undocumented"] = true,
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["SetRotation"] = {
    ["arguments"] = {
    },
    ["name"] = "SetRotation",
    ["signature"] = "PlayerModel:SetRotation(angle)",
    ["returns"] = {
    },
    ["desc"] = "Sets the rotation angle (in radians) of the mesh displayed in the PlayerModel.",
  },
  ["GetUpperEmblemFileName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetUpperEmblemFileName",
    ["signature"] = "TabardModel:GetUpperEmblemFileName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the path to the upper emblem texture file",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["GetUpperEmblemTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetUpperEmblemTexture",
    ["signature"] = "TabardModel:GetUpperEmblemTexture(texture)",
    ["returns"] = {
    },
    ["desc"] = "Returns the upper emblem texture",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["InitializeTabardColors"] = {
    ["arguments"] = {
    },
    ["name"] = "InitializeTabardColors",
    ["signature"] = "TabardModel:InitializeTabardColors()",
    ["returns"] = {
    },
    ["desc"] = "Initailizes the tabard colors",
  },
  ["SetCreature"] = {
    ["undocumented"] = true,
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["GetUpperBackgroundFileName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetUpperBackgroundFileName",
    ["signature"] = "TabardModel:GetUpperBackgroundFileName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the path to the upper background texture file",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["SetSequence"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSequence",
    ["signature"] = "Model:SetSequence(sequence)",
    ["returns"] = {
    },
    ["desc"] = "Sets the model to use the specified animation sequence.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["SetUnit"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUnit",
    ["signature"] = "PlayerModel:SetUnit(unitId)",
    ["returns"] = {
    },
    ["desc"] = "Sets the PlayerModel to display the given unit.",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetLight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetLight",
    ["signature"] = "Model:SetLight(enabled[, omni, dirX, dirY, dirZ, ambIntensity[, ambR, ambG, ambB], dirIntensity[, dirR, dirG, dirB]])",
    ["returns"] = {
    },
    ["desc"] = "Sets the origin of the lightsource for rendering of the model",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["GetLight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLight",
    ["signature"] = "... = Model:GetLight()",
    ["returns"] = {
    },
    ["desc"] = "Returns information about the light source used when rendering the model",
  },
  ["ReplaceIconTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "ReplaceIconTexture",
    ["signature"] = "Model:ReplaceIconTexture(path)",
    ["returns"] = {
    },
    ["desc"] = "Sets the icon texture path used by the model.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["CanSaveTabardNow"] = {
    ["arguments"] = {
    },
    ["name"] = "CanSaveTabardNow",
    ["signature"] = "canSave = TabardModel:CanSaveTabardNow()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the tabard can be saved",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["SetFogNear"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogNear",
    ["signature"] = "Model:SetFogNear(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the near clipping distance for the model's fog.",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["AdvanceTime"] = {
    ["arguments"] = {
    },
    ["name"] = "AdvanceTime",
    ["signature"] = "Model:AdvanceTime()",
    ["returns"] = {
    },
    ["desc"] = "Advances to the next animation frame for the model.",
  },
  ["ClearFog"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearFog",
    ["signature"] = "Model:ClearFog()",
    ["returns"] = {
    },
    ["desc"] = "Disables fog display for the model.",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["RefreshUnit"] = {
    ["arguments"] = {
    },
    ["name"] = "RefreshUnit",
    ["signature"] = "PlayerModel:RefreshUnit()",
    ["returns"] = {
    },
    ["desc"] = "Refreshes the model given its current unit.",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["GetLowerEmblemTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLowerEmblemTexture",
    ["signature"] = "TabardModel:GetLowerEmblemTexture(texture)",
    ["returns"] = {
    },
    ["desc"] = "Returns the lower emblem texture",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["GetFacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFacing",
    ["signature"] = "Model:GetFacing()",
    ["returns"] = {
    },
    ["desc"] = "Gets the current rotation angle of the model in radians.",
  },
  ["SetPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPosition",
    ["signature"] = "Model:SetPosition(x, y, z)",
    ["returns"] = {
    },
    ["desc"] = "Sets the position of the mesh displayed by the Model.",
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["SetFogColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogColor",
    ["signature"] = "Model:SetFogColor(r, g, b[, a])",
    ["returns"] = {
    },
    ["desc"] = "Sets the fog color and enables fog display for the model.",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["ClearModel"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearModel",
    ["signature"] = "Model:ClearModel()",
    ["returns"] = {
    },
    ["desc"] = "Removes the current mesh from the Model object.",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["GetLowerEmblemFileName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLowerEmblemFileName",
    ["signature"] = "TabardModel:GetLowerEmblemFileName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the path to the lower emblem texture file",
  },
  ["GetFogColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogColor",
    ["signature"] = "r, g, b, a = Model:GetFogColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current fog color for the Model.",
  },
  ["Save"] = {
    ["arguments"] = {
    },
    ["name"] = "Save",
    ["signature"] = "TabardModel:Save()",
    ["returns"] = {
    },
    ["desc"] = "Saves the desgined tabard.",
  },
  ["GetFogNear"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogNear",
    ["signature"] = "Model:GetFogNear()",
    ["returns"] = {
    },
    ["desc"] = "Returns the near clipping distance for the model's fog.",
  },
  ["GetPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPosition",
    ["signature"] = "x, y, z = Model:GetPosition()",
    ["returns"] = {
    },
    ["desc"] = "Returns the position of the mesh displayed by the Model object.",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["SetFacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFacing",
    ["signature"] = "Model:SetFacing(facing)",
    ["returns"] = {
    },
    ["desc"] = "Gets the current rotation angle of the model in radians.",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
}
DressUpModel = {
  ["RefreshUnit"] = {
    ["arguments"] = {
    },
    ["name"] = "RefreshUnit",
    ["signature"] = "PlayerModel:RefreshUnit()",
    ["returns"] = {
    },
    ["desc"] = "Refreshes the model given its current unit.",
  },
  ["GetModel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetModel",
    ["signature"] = "Model:GetModel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the file name currently used by the model.",
  },
  ["SetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScript",
    ["signature"] = "Frame:SetScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Sets a function to call for the given widget handler on this frame",
  },
  ["SetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAlpha",
    ["signature"] = "VisibleRegion:SetAlpha(alpha)",
    ["returns"] = {
    },
    ["desc"] = "Sets the alpha value",
  },
  ["GetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop color",
  },
  ["GetEffectiveScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveScale",
    ["signature"] = "Frame:GetEffectiveScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective scale",
  },
  ["StopMovingOrSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StopMovingOrSizing",
    ["signature"] = "Frame:StopMovingOrSizing()",
    ["returns"] = {
    },
    ["desc"] = "Stops the frame from being moved or resized, and saves the position in layout-cache.txt",
  },
  ["SetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameStrata",
    ["signature"] = "Frame:SetFrameStrata(strata)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's frameStrata",
  },
  ["GetScript"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScript",
    ["signature"] = "Frame:GetScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the widget handler for \"type\"",
  },
  ["SetCamera"] = {
    ["arguments"] = {
    },
    ["name"] = "SetCamera",
    ["signature"] = "Model:SetCamera(index)",
    ["returns"] = {
    },
    ["desc"] = "Sets the pre-defined camera view for the model.",
  },
  ["SetResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetResizable",
    ["signature"] = "Frame:SetResizable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is resizable",
  },
  ["GetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "GetParent",
    ["signature"] = "Region:GetParent()",
    ["returns"] = {
    },
    ["desc"] = "Returns the Region's parent object.",
  },
  ["IsShown"] = {
    ["arguments"] = {
    },
    ["name"] = "IsShown",
    ["signature"] = "VisibleRegion:IsShown()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is shown",
  },
  ["GetFrameStrata"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameStrata",
    ["signature"] = "Frame:GetFrameStrata()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current framestrata",
  },
  ["SetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHitRectInsets",
    ["signature"] = "Frame:SetHitRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame's HitRectInsets, which define where the mouse can interact with the frame",
  },
  ["SetFogFar"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogFar",
    ["signature"] = "Model:SetFogFar(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the far clipping distance for the model's fog.",
  },
  ["SetClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampedToScreen",
    ["signature"] = "Frame:SetClampedToScreen(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should be clamped to the screen",
  },
  ["SetModelScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetModelScale",
    ["signature"] = "Model:SetModelScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the mesh displayed by the Model.",
  },
  ["GetModelScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetModelScale",
    ["signature"] = "Model:GetModelScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the mesh displayed by the Model",
  },
  ["GetHitRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHitRectInsets",
    ["signature"] = "left, right, top, bottom = Frame:GetHitRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the inserts for the frame's HitRect",
  },
  ["GetBottom"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBottom",
    ["signature"] = "Region:GetBottom()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels from the top of the screen to the bottom of the Region.",
  },
  ["GetRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRegions",
    ["signature"] = "Frame:GetRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the regions (fontstrings, textures) that belong to this frame",
  },
  ["IgnoreDepth"] = {
    ["undocumented"] = true,
  },
  ["IsVisible"] = {
    ["arguments"] = {
    },
    ["name"] = "IsVisible",
    ["signature"] = "VisibleRegion:IsVisible()",
    ["returns"] = {
    },
    ["desc"] = "Returns if the region is visible",
  },
  ["GetFogFar"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogFar",
    ["signature"] = "Model:GetFogFar()",
    ["returns"] = {
    },
    ["desc"] = "Returns the far clipping distance for the model's fog.",
  },
  ["SetModel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetModel",
    ["signature"] = "Model:SetModel(filename)",
    ["returns"] = {
    },
    ["desc"] = "Sets the model to the specified file.",
  },
  ["SetGlow"] = {
    ["undocumented"] = true,
  },
  ["GetEffectiveDepth"] = {
    ["undocumented"] = true,
  },
  ["SetBackdropColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropColor",
    ["signature"] = "Frame:SetBackdropColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the backdrop color for the frame",
  },
  ["GetID"] = {
    ["arguments"] = {
    },
    ["name"] = "GetID",
    ["signature"] = "Frame:GetID()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's numeric identifier",
  },
  ["IsEventRegistered"] = {
    ["arguments"] = {
    },
    ["name"] = "IsEventRegistered",
    ["signature"] = "Frame:IsEventRegistered(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is registered for the given event",
  },
  ["GetNumChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumChildren",
    ["signature"] = "Frame:GetNumChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of children this frame has",
  },
  ["SetRotation"] = {
    ["arguments"] = {
    },
    ["name"] = "SetRotation",
    ["signature"] = "PlayerModel:SetRotation(angle)",
    ["returns"] = {
    },
    ["desc"] = "Sets the rotation angle (in radians) of the mesh displayed in the PlayerModel.",
  },
  ["GetName"] = {
    ["arguments"] = {
    },
    ["name"] = "GetName",
    ["signature"] = "UIObject:GetName()",
    ["returns"] = {
    },
    ["desc"] = "Returns the name of the object.",
  },
  ["IsMouseEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseEnabled",
    ["signature"] = "Frame:IsMouseEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse enabled",
  },
  ["SetCreature"] = {
    ["undocumented"] = true,
  },
  ["IsFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsFrameType",
    ["signature"] = "Frame:IsFrameType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is of the given type",
  },
  ["GetRight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRight",
    ["signature"] = "Region:GetRight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the right edge of the Region.",
  },
  ["CreateTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTexture",
    ["signature"] = "texture = Frame:CreateTexture(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new Texture for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["DisableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "DisableDrawLayer",
    ["signature"] = "Frame:DisableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Disables rendering of the Frame's specified layer.",
  },
  ["EnableMouse"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouse",
    ["signature"] = "Frame:EnableMouse(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mouse interactivity",
  },
  ["GetChildren"] = {
    ["arguments"] = {
    },
    ["name"] = "GetChildren",
    ["signature"] = "Frame:GetChildren()",
    ["returns"] = {
    },
    ["desc"] = "Returns the list of child frames",
  },
  ["IsUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "IsUserPlaced",
    ["signature"] = "Frame:IsUserPlaced()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is flagged as \"user placed\"",
  },
  ["SetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "SetClampRectInsets",
    ["signature"] = "Frame:SetClampRectInsets(left, right, top, bottom)",
    ["returns"] = {
    },
    ["desc"] = "Sets the clamp rect insets for the frame, so portion of it could move offscreen",
  },
  ["GetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameLevel",
    ["signature"] = "Frame:GetFrameLevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current frame level",
  },
  ["GetEffectiveAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetEffectiveAlpha",
    ["signature"] = "Frame:GetEffectiveAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's effective alpha",
  },
  ["GetNumRegions"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumRegions",
    ["signature"] = "Frame:GetNumRegions()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of regions belonging to this frame",
  },
  ["GetAlpha"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAlpha",
    ["signature"] = "VisibleRegion:GetAlpha()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current alpha value for the region",
  },
  ["GetTop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTop",
    ["signature"] = "Region:GetTop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between the top of the screen and the top of the Region.",
  },
  ["CanChangeProtectedState"] = {
    ["arguments"] = {
    },
    ["name"] = "CanChangeProtectedState",
    ["signature"] = "Region:CanChangeProtectedState()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not a frame can make a protected change",
  },
  ["GetCenter"] = {
    ["arguments"] = {
    },
    ["name"] = "GetCenter",
    ["signature"] = "x, y = Region:GetCenter()",
    ["returns"] = {
    },
    ["desc"] = "Returns the screen coordinates of the Region's center.",
  },
  ["SetSequence"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSequence",
    ["signature"] = "Model:SetSequence(sequence)",
    ["returns"] = {
    },
    ["desc"] = "Sets the model to use the specified animation sequence.",
  },
  ["SetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetHeight",
    ["signature"] = "Region:SetHeight(height)",
    ["returns"] = {
    },
    ["desc"] = "Sets the height of this region to the given value",
  },
  ["RegisterForDrag"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterForDrag",
    ["signature"] = "Frame:RegisterForDrag(...)",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for dragging via specific mouse buttons",
  },
  ["SetUnit"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUnit",
    ["signature"] = "PlayerModel:SetUnit(unitId)",
    ["returns"] = {
    },
    ["desc"] = "Sets the PlayerModel to display the given unit.",
  },
  ["SetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMaxResize",
    ["signature"] = "Frame:SetMaxResize(maxWidth, maxHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the maximum resize limits for the frame",
  },
  ["GetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "GetWidth",
    ["signature"] = "Region:GetWidth()",
    ["returns"] = {
    },
    ["desc"] = "Returns the width of the Region",
  },
  ["SetLight"] = {
    ["arguments"] = {
    },
    ["name"] = "SetLight",
    ["signature"] = "Model:SetLight(enabled[, omni, dirX, dirY, dirZ, ambIntensity[, ambR, ambG, ambB], dirIntensity[, dirR, dirG, dirB]])",
    ["returns"] = {
    },
    ["desc"] = "Sets the origin of the lightsource for rendering of the model",
  },
  ["SetMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMovable",
    ["signature"] = "Frame:SetMovable(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame is movable",
  },
  ["SetAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAllPoints",
    ["signature"] = "Region:SetAllPoints(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets all anchors of this region to match the given region's",
  },
  ["Show"] = {
    ["arguments"] = {
    },
    ["name"] = "Show",
    ["signature"] = "VisibleRegion:Show()",
    ["returns"] = {
    },
    ["desc"] = "Shows the region",
  },
  ["GetHeight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetHeight",
    ["signature"] = "Region:GetHeight()",
    ["returns"] = {
    },
    ["desc"] = "Returns the height of the region.",
  },
  ["EnableKeyboard"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableKeyboard",
    ["signature"] = "Frame:EnableKeyboard()",
    ["returns"] = {
    },
    ["desc"] = "Enables or disabled keyboard interactivity",
  },
  ["GetLight"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLight",
    ["signature"] = "... = Model:GetLight()",
    ["returns"] = {
    },
    ["desc"] = "Returns information about the light source used when rendering the model",
  },
  ["ReplaceIconTexture"] = {
    ["arguments"] = {
    },
    ["name"] = "ReplaceIconTexture",
    ["signature"] = "Model:ReplaceIconTexture(path)",
    ["returns"] = {
    },
    ["desc"] = "Sets the icon texture path used by the model.",
  },
  ["GetObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetObjectType",
    ["signature"] = "UIObject:GetObjectType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the object (\"Frame\", \"Button\", etc.).",
  },
  ["IsResizable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsResizable",
    ["signature"] = "Frame:IsResizable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is resizable",
  },
  ["IsObjectType"] = {
    ["arguments"] = {
    },
    ["name"] = "IsObjectType",
    ["signature"] = "UIObject:IsObjectType(type)",
    ["returns"] = {
    },
    ["desc"] = "Returns whether the object is of the given type (\"Frame\", \"Button\", etc.).",
  },
  ["SetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPoint",
    ["signature"] = "Region:SetPoint(\"point\" [, region [, \"relativePoint\"]] [, offsetX, offsetY])",
    ["returns"] = {
    },
    ["desc"] = "Sets a given anchor point on this region",
  },
  ["IsMouseWheelEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMouseWheelEnabled",
    ["signature"] = "Frame:IsMouseWheelEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is mouse wheel enabled",
  },
  ["RegisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterEvent",
    ["signature"] = "Frame:RegisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for an event",
  },
  ["SetID"] = {
    ["arguments"] = {
    },
    ["name"] = "SetID",
    ["signature"] = "Frame:SetID(ID)",
    ["returns"] = {
    },
    ["desc"] = "Sets the numeric identifier for the frame",
  },
  ["GetPoint"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPoint",
    ["signature"] = "point, relativeTo, relativePoint, offsetX, offsetY = Region:GetPoint(index)",
    ["returns"] = {
    },
    ["desc"] = "Returns the specified anchor point for the frame.",
  },
  ["RegisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "RegisterAllEvents",
    ["signature"] = "Frame:RegisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Registers the frame for all events",
  },
  ["GetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMinResize",
    ["signature"] = "x, y = Frame:GetMinResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the minimum resize height and width",
  },
  ["SetFogNear"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogNear",
    ["signature"] = "Model:SetFogNear(value)",
    ["returns"] = {
    },
    ["desc"] = "Sets the near clipping distance for the model's fog.",
  },
  ["IsKeyboardEnabled"] = {
    ["arguments"] = {
    },
    ["name"] = "IsKeyboardEnabled",
    ["signature"] = "Frame:IsKeyboardEnabled()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is keyboard enabled",
  },
  ["AdvanceTime"] = {
    ["arguments"] = {
    },
    ["name"] = "AdvanceTime",
    ["signature"] = "Model:AdvanceTime()",
    ["returns"] = {
    },
    ["desc"] = "Advances to the next animation frame for the model.",
  },
  ["UnregisterEvent"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterEvent",
    ["signature"] = "Frame:UnregisterEvent(\"event\")",
    ["returns"] = {
    },
    ["desc"] = "Unregistered the frame for the given event",
  },
  ["GetLeft"] = {
    ["arguments"] = {
    },
    ["name"] = "GetLeft",
    ["signature"] = "Region:GetLeft()",
    ["returns"] = {
    },
    ["desc"] = "Returns the distance in pixels between left edge of the screen and the left edge of the Region.",
  },
  ["SetParent"] = {
    ["arguments"] = {
    },
    ["name"] = "SetParent",
    ["signature"] = "Region:SetParent(region or \"regionName\")",
    ["returns"] = {
    },
    ["desc"] = "Sets the parent of this region to the given region",
  },
  ["GetClampRectInsets"] = {
    ["arguments"] = {
    },
    ["name"] = "GetClampRectInsets",
    ["signature"] = "Frame:GetClampRectInsets()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rect insets for the clampedtoscreen system",
  },
  ["HookScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HookScript",
    ["signature"] = "Frame:HookScript(\"type\", function)",
    ["returns"] = {
    },
    ["desc"] = "Securely hooks a widget handler script",
  },
  ["EnableMouseWheel"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableMouseWheel",
    ["signature"] = "Frame:EnableMouseWheel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Enables or disables mousewheel interactivity",
  },
  ["SetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdropBorderColor",
    ["signature"] = "Frame:SetBackdropBorderColor(red, green, blue [, alpha])",
    ["returns"] = {
    },
    ["desc"] = "Sets the color of the frame's backdrop border",
  },
  ["StartMoving"] = {
    ["arguments"] = {
    },
    ["name"] = "StartMoving",
    ["signature"] = "Frame:StartMoving()",
    ["returns"] = {
    },
    ["desc"] = "Start moving the frame",
  },
  ["Lower"] = {
    ["arguments"] = {
    },
    ["name"] = "Lower",
    ["signature"] = "Frame:Lower()",
    ["returns"] = {
    },
    ["desc"] = "Lowers the frame's frameLevel",
  },
  ["GetRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetRect",
    ["signature"] = "left, right, width, height = Region:GetRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the rectangle position and size for the Region.",
  },
  ["IsClampedToScreen"] = {
    ["arguments"] = {
    },
    ["name"] = "IsClampedToScreen",
    ["signature"] = "Frame:IsClampedToScreen()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is clamped to the screen",
  },
  ["IsMovable"] = {
    ["arguments"] = {
    },
    ["name"] = "IsMovable",
    ["signature"] = "Frame:IsMovable()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is movable",
  },
  ["TryOn"] = {
    ["arguments"] = {
    },
    ["name"] = "TryOn",
    ["signature"] = "DressUpModel:TryOn(item)",
    ["returns"] = {
    },
    ["desc"] = "Adds item (id, string, or link) to the DressUpModel.",
  },
  ["EnableDrawLayer"] = {
    ["arguments"] = {
    },
    ["name"] = "EnableDrawLayer",
    ["signature"] = "Frame:EnableDrawLayer(layer)",
    ["returns"] = {
    },
    ["desc"] = "Enables rendering of the Frame's specified layer.",
  },
  ["GetNumPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "GetNumPoints",
    ["signature"] = "Region:GetNumPoints()",
    ["returns"] = {
    },
    ["desc"] = "Returns the number of anchor points set for the frame.",
  },
  ["SetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "SetBackdrop",
    ["signature"] = "Frame:SetBackdrop({bgFile = \"bgFile\", edgeFile = \"edgeFile\", tile = false, tileSize = 0, edgeSize = 32, insets = { left = 0, right = 0, top = 0, bottom = 0 }})",
    ["returns"] = {
    },
    ["desc"] = "Sets a frame's backdrop as defined by a table",
  },
  ["GetBoundsRect"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBoundsRect",
    ["signature"] = "x, y, width, height = Frame:GetBoundsRect()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's boundaries",
  },
  ["SetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetBackdropBorderColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdropBorderColor",
    ["signature"] = "red, green, blue, alpha = Frame:GetBackdropBorderColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the frame's backdrop border color",
  },
  ["GetBackdrop"] = {
    ["arguments"] = {
    },
    ["name"] = "GetBackdrop",
    ["signature"] = "backdrop = Frame:GetBackdrop()",
    ["returns"] = {
    },
    ["desc"] = "Returns the backdrop information for the frame",
  },
  ["GetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "GetScale",
    ["signature"] = "Frame:GetScale()",
    ["returns"] = {
    },
    ["desc"] = "Returns the scale of the frame",
  },
  ["IsProtected"] = {
    ["arguments"] = {
    },
    ["name"] = "IsProtected",
    ["signature"] = "isProtected = Region:IsProtected()",
    ["returns"] = {
    },
    ["desc"] = "Indicates that insecure code cannot call protected methods of this region during combat.",
  },
  ["IsIgnoringDepth"] = {
    ["undocumented"] = true,
  },
  ["GetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "GetAttribute",
    ["signature"] = "Frame:GetAttribute(\"name\")",
    ["returns"] = {
    },
    ["desc"] = "Returns the name attribute",
  },
  ["Undress"] = {
    ["arguments"] = {
    },
    ["name"] = "Undress",
    ["signature"] = "DressUpModel:Undress()",
    ["returns"] = {
    },
    ["desc"] = "Set the model to reflect the character without inventory.",
  },
  ["GetFrameType"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFrameType",
    ["signature"] = "Frame:GetFrameType()",
    ["returns"] = {
    },
    ["desc"] = "Returns the type of the frame, as a string",
  },
  ["GetTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "GetTitleRegion",
    ["signature"] = "Frame:GetTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Returns the TitleRegion object for the frame.",
  },
  ["Raise"] = {
    ["arguments"] = {
    },
    ["name"] = "Raise",
    ["signature"] = "Frame:Raise()",
    ["returns"] = {
    },
    ["desc"] = "Raises the frame's frameLevel",
  },
  ["ClearModel"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearModel",
    ["signature"] = "Model:ClearModel()",
    ["returns"] = {
    },
    ["desc"] = "Removes the current mesh from the Model object.",
  },
  ["Hide"] = {
    ["arguments"] = {
    },
    ["name"] = "Hide",
    ["signature"] = "VisibleRegion:Hide()",
    ["returns"] = {
    },
    ["desc"] = "Hides the region",
  },
  ["AllowAttributeChanges"] = {
    ["arguments"] = {
    },
    ["name"] = "AllowAttributeChanges",
    ["signature"] = "Frame:AllowAttributeChanges()",
    ["returns"] = {
    },
    ["desc"] = "Temporarily allows insecure code to modify attributes on the Frame during combat.",
  },
  ["IsToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "IsToplevel",
    ["signature"] = "Frame:IsToplevel()",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame is at the top level",
  },
  ["Dress"] = {
    ["arguments"] = {
    },
    ["name"] = "Dress",
    ["signature"] = "DressUpModel:Dress()",
    ["returns"] = {
    },
    ["desc"] = "Set the model to reflect the character's current inventory.",
  },
  ["SetPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "SetPosition",
    ["signature"] = "Model:SetPosition(x, y, z)",
    ["returns"] = {
    },
    ["desc"] = "Sets the position of the mesh displayed by the Model.",
  },
  ["SetWidth"] = {
    ["arguments"] = {
    },
    ["name"] = "SetWidth",
    ["signature"] = "Region:SetWidth(width)",
    ["returns"] = {
    },
    ["desc"] = "Sets the width of this region to the given value",
  },
  ["ClearAllPoints"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearAllPoints",
    ["signature"] = "Region:ClearAllPoints()",
    ["returns"] = {
    },
    ["desc"] = "Clear all anchor point for the given region",
  },
  ["StartSizing"] = {
    ["arguments"] = {
    },
    ["name"] = "StartSizing",
    ["signature"] = "Frame:StartSizing()",
    ["returns"] = {
    },
    ["desc"] = "Start resizing the frame",
  },
  ["SetUserPlaced"] = {
    ["arguments"] = {
    },
    ["name"] = "SetUserPlaced",
    ["signature"] = "Frame:SetUserPlaced(flag)",
    ["returns"] = {
    },
    ["desc"] = "Flags the frame as user placed, or not",
  },
  ["SetFogColor"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFogColor",
    ["signature"] = "Model:SetFogColor(r, g, b[, a])",
    ["returns"] = {
    },
    ["desc"] = "Sets the fog color and enables fog display for the model.",
  },
  ["SetToplevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetToplevel",
    ["signature"] = "Frame:SetToplevel(flag)",
    ["returns"] = {
    },
    ["desc"] = "Sets whether or not the frame should raise itself to the top frame level when clicked",
  },
  ["GetFacing"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFacing",
    ["signature"] = "Model:GetFacing()",
    ["returns"] = {
    },
    ["desc"] = "Gets the current rotation angle of the model in radians.",
  },
  ["GetMaxResize"] = {
    ["arguments"] = {
    },
    ["name"] = "GetMaxResize",
    ["signature"] = "x, y = Frame:GetMaxResize()",
    ["returns"] = {
    },
    ["desc"] = "Returns the maximum resize width and height",
  },
  ["SetScale"] = {
    ["arguments"] = {
    },
    ["name"] = "SetScale",
    ["signature"] = "Frame:SetScale(scale)",
    ["returns"] = {
    },
    ["desc"] = "Sets the scale of the frame",
  },
  ["HasScript"] = {
    ["arguments"] = {
    },
    ["name"] = "HasScript",
    ["signature"] = "Frame:HasScript(\"type\")",
    ["returns"] = {
    },
    ["desc"] = "Returns whether or not the frame has the widget handler \"type\"",
  },
  ["SetSequenceTime"] = {
    ["arguments"] = {
    },
    ["name"] = "SetSequenceTime",
    ["signature"] = "Model:SetSequenceTime(sequence, time)",
    ["returns"] = {
    },
    ["desc"] = "Sets the animation sequence and time index for the Model.",
  },
  ["SetMinResize"] = {
    ["arguments"] = {
    },
    ["name"] = "SetMinResize",
    ["signature"] = "Frame:SetMinResize(minWidth, minHeight)",
    ["returns"] = {
    },
    ["desc"] = "Sets the minimum resize limits for the frame",
  },
  ["UnregisterAllEvents"] = {
    ["arguments"] = {
    },
    ["name"] = "UnregisterAllEvents",
    ["signature"] = "Frame:UnregisterAllEvents()",
    ["returns"] = {
    },
    ["desc"] = "Unregisters all events for the frame",
  },
  ["CreateFontString"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateFontString",
    ["signature"] = "fontString = Frame:CreateFontString(name[, layer[, inherits]])",
    ["returns"] = {
    },
    ["desc"] = "Creates a new FontString for the Frame on the given layer, optionally inheriting from a template.",
  },
  ["CreateTitleRegion"] = {
    ["arguments"] = {
    },
    ["name"] = "CreateTitleRegion",
    ["signature"] = "Frame:CreateTitleRegion()",
    ["returns"] = {
    },
    ["desc"] = "Creates a title region for the frame",
  },
  ["SetAttribute"] = {
    ["arguments"] = {
    },
    ["name"] = "SetAttribute",
    ["signature"] = "Frame:SetAttribute(\"name\", value)",
    ["returns"] = {
    },
    ["desc"] = "Sets an attribute on the given frame",
  },
  ["GetFogColor"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogColor",
    ["signature"] = "r, g, b, a = Model:GetFogColor()",
    ["returns"] = {
    },
    ["desc"] = "Returns the current fog color for the Model.",
  },
  ["GetDepth"] = {
    ["undocumented"] = true,
  },
  ["GetFogNear"] = {
    ["arguments"] = {
    },
    ["name"] = "GetFogNear",
    ["signature"] = "Model:GetFogNear()",
    ["returns"] = {
    },
    ["desc"] = "Returns the near clipping distance for the model's fog.",
  },
  ["GetPosition"] = {
    ["arguments"] = {
    },
    ["name"] = "GetPosition",
    ["signature"] = "x, y, z = Model:GetPosition()",
    ["returns"] = {
    },
    ["desc"] = "Returns the position of the mesh displayed by the Model object.",
  },
  ["SetFrameLevel"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFrameLevel",
    ["signature"] = "Frame:SetFrameLevel(level)",
    ["returns"] = {
    },
    ["desc"] = "Sets the frame level of the frame",
  },
  ["SetFacing"] = {
    ["arguments"] = {
    },
    ["name"] = "SetFacing",
    ["signature"] = "Model:SetFacing(facing)",
    ["returns"] = {
    },
    ["desc"] = "Gets the current rotation angle of the model in radians.",
  },
  ["ClearFog"] = {
    ["arguments"] = {
    },
    ["name"] = "ClearFog",
    ["signature"] = "Model:ClearFog()",
    ["returns"] = {
    },
    ["desc"] = "Disables fog display for the model.",
  },
}
